<?php 

$shortname = 'myband_';

require_once(TEMPLATEPATH . '/includes/functions/comments.php'); 
require_once(TEMPLATEPATH . '/includes/functions/sidebars.php');
require_once(TEMPLATEPATH . '/theme-assets/php/core_functions.php'); 
require_once(TEMPLATEPATH . '/theme-assets/php/custom_functions.php');
require_once(TEMPLATEPATH . '/includes/mbfileshop/main.php');
require_once(TEMPLATEPATH . '/theme-assets/wp-helper-scripts/wp-pagenavi.php');
require_once(TEMPLATEPATH . '/theme-assets/wp-custom-fields/post-fields-0.php');
require_once(TEMPLATEPATH . '/theme-assets/wp-custom-fields/event-fields-0.php');
require_once(TEMPLATEPATH . '/shortcodes/shortcodes.php');    
load_theme_textdomain('myband',get_template_directory().'/languages');
include TEMPLATEPATH . '/theme-assets/wp-admin-options/options-0.php';
include TEMPLATEPATH . '/theme-assets/wp-admin-options/options-1.php';
include TEMPLATEPATH . '/theme-assets/wp-admin-options/options-2.php';
include TEMPLATEPATH . '/theme-assets/wp-admin-options/options-3.php';
include TEMPLATEPATH . '/theme-assets/wp-admin-options/options-4.php';
include TEMPLATEPATH . '/theme-assets/wp-admin-options/options-5.php';


add_theme_support( 'post-thumbnails' );
add_theme_support( 'post-formats', array( 'video','aside' ) );
function remove_metaboxes() {
 remove_meta_box( 'postcustom' , 'post' , 'normal' );
}
add_action('init', 'post_type_album');
add_action('init', 'post_type_event');


function post_type_event() {
	register_post_type( 'event', array(
		'label' => __('MyBand events'),
		'public' => true,
		'show_ui' => true,
		'_builtin' => false,
		'_edit_link' => 'post.php?post=%d',
		'capability_type' => 'post',
		'hierarchical' => false,
		'rewrite' => array("slug" => "event"),
		'query_var' => "event",
		'menu_position' => 7,
		'menu_icon'=>get_bloginfo('template_directory').'/images/admin-event-icon.png',
		'supports' => array('title', 'excerpt', 'editor', 'thumbnail','comments'),
	));
	flush_rewrite_rules( false );
}

function post_type_album() {
	register_post_type( 'album', array(
		'label' => __('MyBand albums'),
		'public' => true,
		'show_ui' => true,
		'_builtin' => false, // It's a custom post type, not built in
		'_edit_link' => 'post.php?post=%d',
		'capability_type' => 'post',
		'hierarchical' => true,
		'rewrite' => array("slug" => "albums"), // Permalinks
		'query_var' => "album",
		'menu_position' => 6,
		'menu_icon'=>get_bloginfo('template_directory').'/images/admin-album-icon.png',
		'supports' => array('title', 'excerpt', 'editor', 'thumbnail','comments'),
	));
	flush_rewrite_rules( false );
	
	//register taxonomy for portfolio
	register_taxonomy('album_category','album',array(
		'hierarchical' => true,
		'labels' => array(
			'name' => _x( 'Album Categories', 'taxonomy general name' ),
			'singular_name' => _x( 'Album Category', 'taxonomy singular name' ),
			'search_items' =>  __( 'Search Categories' ),
			'popular_items' => __( 'Popular Categories' ),
			'all_items' => __( 'All Categories' ),
			'parent_item' => null,
			'parent_item_colon' => null,
			'edit_item' => __( 'Edit Album Category' ), 
			'update_item' => __( 'Update Album Category' ),
			'add_new_item' => __( 'Add New Album Category' ),
			'new_item_name' => __( 'New Album Category Name' ),
			'separate_items_with_commas' => __( 'Separate album category with commas' ),
			'add_or_remove_items' => __( 'Add or remove album category' ),
			'choose_from_most_used' => __( 'Choose from the most used album category' ),
			'menu_name' => __( 'Album Categories' ),
		),
		'public' => true,
		'show_in_nav_menus' => false,
		'show_ui' => true,
		'show_tagcloud' => false,
		'query_var' => false,
		'rewrite' => array(
			'slug' => 'album',
			'hierarchical' => true
		),
	));	
}

function insertThumbnailRSS($content) {
global $post;

$thumb = ''; $thumb = get_post_meta($post->ID, 'Thumbnail',true);

if ( has_post_thumbnail( $post->ID ) ){
$content = '<p>' . get_the_post_thumbnail( $post->ID, 'medium' ) . '</p>' . $content;
} else if ($thumb <> '') {
$content = '<p>' . '<img src="'.get_bloginfo('template_directory').'/timthumb.php?src='.$thumb.'&amp;h=200&amp;w=300&amp;zc=1"/>' . '</p>' . $content;
}

return $content;
}
add_filter('the_excerpt_rss', 'insertThumbnailRSS');
add_filter('the_content_feed', 'insertThumbnailRSS');

function register_main_menus() {
	register_nav_menus(
		array(
			'primary-menu' => __( 'Primary Menu' ),
			'footer-menu' => __( 'Footer Menu' )
		)
	);
}
if (function_exists('register_nav_menus')) add_action( 'init', 'register_main_menus' );

$wp_ver = substr($GLOBALS['wp_version'],0,3);
if ($wp_ver >= 2.8) include(TEMPLATEPATH . '/includes/widgets.php');

function mb_get_calendar($initial = true, $echo = true) {
	global $wpdb, $monthnum, $year, $wp_locale, $posts, $shortname;
	
	$blogcat = get_cat_ID(get_option($shortname . '_blog_cat'));
	$blogcats_array = array_merge( array($blogcat), get_term_children($blogcat, 'category') );
	$blogcats = implode(",",$blogcats_array);
	$blog_category_posts_id = $wpdb->get_results("SELECT $wpdb->posts.ID "
								. "FROM $wpdb->posts "
								. "WHERE ($wpdb->posts.post_type = 'event') AND ($wpdb->posts.post_status = 'publish' OR $wpdb->posts.post_status = 'future') "
								. "ORDER BY post_date DESC ", ARRAY_A
								);

	
		
	if ( isset($_GET['evmonth']) )
		$m = $_GET['evmonth'];
	else {
		$recent_post_info = $wpdb->get_row("SELECT DISTINCT ID, MONTH(now()) AS month, YEAR(now()) AS year
			FROM $wpdb->posts
			WHERE post_type = 'event' AND (post_status = 'publish' OR post_status = 'future') 
			ORDER BY post_date DESC
			LIMIT 1");
			
		$m = $recent_post_info->year . zeroise($recent_post_info->month,2); 
	}
	
	$evpostid = $_GET['evpostid'];
	if ( $evpostid == '' ) {
		if ( isset($recent_post_info) ) $evpostid = $recent_post_info->ID;
		else {
			$recentyear = substr($m,0,4);
			$recentmonth = substr($m,5,2);
			$recent_post_ID = $wpdb->get_results("SELECT ID "
				."FROM $wpdb->posts "
				."WHERE YEAR(post_date) = '$recentyear' "
				."AND MONTH(post_date) = '$recentmonth' "
				."AND post_type = 'event' AND (post_status = 'publish' OR post_status = 'future') "
				."ORDER BY post_date DESC LIMIT 1"
			);
			$evpostid = $recent_post_ID[0]->ID;
		}
	}
		
	$cache = array();
	$key = md5( $m . $monthnum . $year );
	
	if ( $cache = wp_cache_get( 'mb_get_calendar', 'calendar' ) ) {
		if ( is_array($cache) && isset( $cache[ $key ] ) ) {
			if ( $echo ) {
				echo apply_filters( 'mb_get_calendar',  $cache[$key] );
				return;
			} else {
				return apply_filters( 'mb_get_calendar',  $cache[$key] );
			}
		}
	}

	if ( !is_array($cache) )
		$cache = array();

	// Quick check. If we have no posts at all, abort!
	if ( !$posts ) {
		$gotsome = $wpdb->get_var("SELECT 1 as test FROM $wpdb->posts WHERE post_type = 'event' AND post_status = 'publish' LIMIT 1");
		if ( !$gotsome ) {
			$cache[ $key ] = '';
			wp_cache_set( 'mb_get_calendar', $cache, 'calendar' );
			return;
		}
	}

	if ( isset($_GET['w']) )
		$w = ''.intval($_GET['w']);

	// week_begins = 0 stands for Sunday
	$week_begins = intval(get_option('start_of_week'));

	// Let's figure out when we are
	if ( !empty($monthnum) && !empty($year) ) {
		$thismonth = ''.zeroise(intval($monthnum), 2);
		$thisyear = ''.intval($year);
	} elseif ( !empty($w) ) {
		// We need to get the month from MySQL
		$thisyear = ''.intval(substr($m, 0, 4));
		$d = (($w - 1) * 7) + 6; //it seems MySQL's weeks disagree with PHP's
		$thismonth = $wpdb->get_var("SELECT DATE_FORMAT((DATE_ADD('${thisyear}0101', INTERVAL $d DAY) ), '%m')");
	} elseif ( !empty($m) ) {
		$thisyear = ''.intval(substr($m, 0, 4));
		if ( strlen($m) < 6 )
				$thismonth = '01';
		else
				$thismonth = ''.zeroise(intval(substr($m, 4, 2)), 2);
	} else {
		$thisyear = gmdate('Y', current_time('timestamp'));
		$thismonth = gmdate('m', current_time('timestamp'));
	}

	$unixmonth = mktime(0, 0 , 0, $thismonth, 1, $thisyear);

	// Get the next and previous month and year with at least one post
	$previous = $wpdb->get_row("SELECT DISTINCT MONTH(STR_TO_DATE($wpdb->postmeta.meta_value, '%d-%b-%Y')) AS month, YEAR(STR_TO_DATE($wpdb->postmeta.meta_value, '%d-%b-%Y')) AS year
		,STR_TO_DATE($wpdb->postmeta.meta_value, '%d-%b-%Y') as last_date
		FROM $wpdb->posts,$wpdb->postmeta
		WHERE STR_TO_DATE($wpdb->postmeta.meta_value, '%d-%b-%Y') < '$thisyear-$thismonth-01' 
		AND $wpdb->posts.ID = $wpdb->postmeta.post_id  AND $wpdb->postmeta.meta_key = 'venue_date_value' 
		AND $wpdb->posts.post_type = 'event' AND ($wpdb->posts.post_status = 'publish' OR $wpdb->posts.post_status = 'future') 
			ORDER BY last_date DESC
			LIMIT 1");
		$next = $wpdb->get_row("SELECT	DISTINCT MONTH(STR_TO_DATE($wpdb->postmeta.meta_value, '%d-%b-%Y')) AS month, YEAR(STR_TO_DATE($wpdb->postmeta.meta_value, '%d-%b-%Y')) AS year
		,STR_TO_DATE($wpdb->postmeta.meta_value, '%d-%b-%Y') as last_date
		FROM $wpdb->posts,$wpdb->postmeta
		WHERE STR_TO_DATE($wpdb->postmeta.meta_value, '%d-%b-%Y') >	'$thisyear-$thismonth-01'
		AND $wpdb->posts.ID = $wpdb->postmeta.post_id  AND $wpdb->postmeta.meta_key = 'venue_date_value' 
		AND MONTH( STR_TO_DATE($wpdb->postmeta.meta_value, '%d-%b-%Y') ) != MONTH( '$thisyear-$thismonth-01' )
		AND $wpdb->posts.post_type = 'event' AND ($wpdb->posts.post_status = 'publish' OR $wpdb->posts.post_status = 'future') 
			ORDER	BY last_date ASC
			LIMIT 1");

	/* translators: Calendar caption: 1: month name, 2: 4-digit year */
	$calendar_caption = _x('%1$s %2$s', 'calendar caption');
	$calendar_output = '<div id="mb_custom_calendar">';
	$calendar_output .= "\n" . '<div id="custom_calendar" class="clearfix">';
	$calendar_output .= "\n" . '<table id="wp-custom-calendar" summary="' . esc_attr__('Calendar') . '">
	<caption>' . sprintf($calendar_caption, $wp_locale->get_month($thismonth), date('Y', $unixmonth)) . '</caption>
	<thead>
	<tr>';

	$myweek = array();

	for ( $wdcount=0; $wdcount<=6; $wdcount++ ) {
		$myweek[] = $wp_locale->get_weekday(($wdcount+$week_begins)%7);
	}
	
	$initial = false;
	$wd_i = 0;
	foreach ( $myweek as $wd ) {
		$wd_i++;
		$day_name = (true == $initial) ? $wp_locale->get_weekday_initial($wd) : $wp_locale->get_weekday_abbrev($wd);
		$wd = esc_attr($wd);
		$calendar_output .= "\n\t\t<th id=\"wd_$wd_i\" scope=\"col\" title=\"$wd\">$day_name</th>";
	}

	$calendar_output .= '
	</tr>
	</thead>

	<tfoot>
	<tr>';
	
	$calendar_page = ( is_home() ) ? get_bloginfo('url') : get_permalink();
	
	if ( $previous ) {
		$calendar_output .= "\n\t\t".'<td colspan="3" class="ev-page" id="prev"><a href="'.add_query_arg('evmonth', $previous->year . zeroise($previous->month,2), $calendar_page). '" title="' . sprintf(__('View posts for %1$s %2$s'), $wp_locale->get_month($previous->month), date('Y', mktime(0, 0 , 0, $previous->month, 1, $previous->year))) . '">&laquo; ' . $wp_locale->get_month_abbrev($wp_locale->get_month($previous->month)) . '</a></td>';
	} else {
		$calendar_output .= "\n\t\t".'<td colspan="3" class="ev-page" id="prev" class="pad">&nbsp;</td>';
	}

	$calendar_output .= "\n\t\t".'<td class="pad">&nbsp;</td>';

	if ( $next ) {
		$calendar_output .= "\n\t\t".'<td colspan="3" class="ev-page" id="next"><a href="' . add_query_arg('evmonth', $next->year . zeroise($next->month,2), $calendar_page) . '" title="' . esc_attr( sprintf(__('View posts for %1$s %2$s'), $wp_locale->get_month($next->month), date('Y', mktime(0, 0 , 0, $next->month, 1, $next->year))) ) . '">' . $wp_locale->get_month_abbrev($wp_locale->get_month($next->month)) . ' &raquo;</a></td>';
	} else {
		$calendar_output .= "\n\t\t".'<td colspan="3" class="ev-page" id="next" class="pad">&nbsp;</td>';
	}
	
	// See how much we should pad in the beginning
	$pad = calendar_week_mod(date('w', $unixmonth)-$week_begins);
	
	$pad_class = ( $pad >= 5 ) ? " class='et_pad'" : '';
	
	$calendar_output .= "
	</tr>
	</tfoot>

	<tbody>
	<tr{$pad_class}>";

	// Get days with posts
	$dayswithposts = $wpdb->get_results("SELECT DISTINCT DAYOFMONTH(STR_TO_DATE($wpdb->postmeta.meta_value, '%d-%b-%Y'))
		FROM $wpdb->posts,$wpdb->postmeta WHERE MONTH(STR_TO_DATE($wpdb->postmeta.meta_value, '%d-%b-%Y')) = '$thismonth'
		AND YEAR(STR_TO_DATE($wpdb->postmeta.meta_value, '%d-%b-%Y')) = '$thisyear' 
		AND $wpdb->posts.ID = $wpdb->postmeta.post_id  AND $wpdb->postmeta.meta_key = 'venue_date_value'
		AND $wpdb->posts.post_type = 'event' AND ($wpdb->posts.post_status = 'publish' OR $wpdb->posts.post_status = 'future') 
		", ARRAY_N);
	if ( $dayswithposts ) {
		foreach ( (array) $dayswithposts as $daywith ) {
			$daywithpost[] = $daywith[0];
		}
	} else {
		$daywithpost = array();
	}

	if (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE') !== false || stripos($_SERVER['HTTP_USER_AGENT'], 'camino') !== false || stripos($_SERVER['HTTP_USER_AGENT'], 'safari') !== false)
		$ak_title_separator = "\n";
	else
		$ak_title_separator = ', ';

	$ak_titles_for_day = array();
	$ak_post_titles = $wpdb->get_results("SELECT $wpdb->posts.ID, $wpdb->posts.post_title, DAYOFMONTH(STR_TO_DATE($wpdb->postmeta.meta_value, '%d-%b-%Y')) as dom "
		."FROM $wpdb->posts, $wpdb->postmeta "
		."WHERE YEAR(STR_TO_DATE($wpdb->postmeta.meta_value, '%d-%b-%Y')) = '$thisyear' "
		."AND MONTH(STR_TO_DATE($wpdb->postmeta.meta_value, '%d-%b-%Y')) = '$thismonth' "
		."AND $wpdb->posts.ID = $wpdb->postmeta.post_id  AND $wpdb->postmeta.meta_key = 'venue_date_value' "
		."AND $wpdb->posts.post_type = 'event' AND ($wpdb->posts.post_status = 'publish' OR $wpdb->posts.post_status = 'future') "
	);
	//$post_link='';	
	if ( $ak_post_titles ) {
		foreach ( (array) $ak_post_titles as $ak_post_title ) {
				$arr_params = array ( 'evmonth' => $thisyear . zeroise($thismonth,2), 'evpostid' => $ak_post_title->ID );
				
				$ak_categories = get_the_category( $ak_post_title->ID );
				$ak_first_category = $ak_categories[0]->cat_name;
				$post_link=get_permalink($ak_post_title->ID);								
				$post_title = esc_attr( apply_filters( 'the_title', $ak_post_title->post_title, $ak_post_title->ID ) );
				$current_post = get_post($ak_post_title->ID);

				if ( empty($ak_titles_for_day['day_'.$ak_post_title->dom]) )
					$ak_titles_for_day['day_'.$ak_post_title->dom] = '';
				if ( empty($ak_titles_for_day["$ak_post_title->dom"]) ) // first one
					$ak_titles_for_day["$ak_post_title->dom"] = '<span class="feat_title"><a href="'.get_permalink($ak_post_title->ID).'" title="'.$post_title.'">'.truncate_title(18,false,$post_title).'</a></span>';
				else
					$ak_titles_for_day["$ak_post_title->dom"] .= '<span class="feat_title"><a href="'.get_permalink($ak_post_title->ID).'" title="'.$post_title.'">'.truncate_title(18,false,$post_title).'</a></span>';
		}
	}
	
	if ( 0 != $pad )
		$calendar_output .= "\n\t\t".'<td colspan="'. esc_attr($pad) .'" class="pad">&nbsp;</td>';

	$daysinmonth = intval(date('t', $unixmonth));
	for ( $day = 1; $day <= $daysinmonth; ++$day ) {
		$dwp_class = '';
		if ( in_array($day, $daywithpost) )
			$dwp_class = ' class="dwp"';
		
		if ( isset($newrow) && $newrow )
			$calendar_output .= "\n\t</tr>\n\t<tr{$pad_class}>\n\t\t";
		$newrow = false;

		if ( $day == gmdate('j', current_time('timestamp')) && $thismonth == gmdate('m', current_time('timestamp')) && $thisyear == gmdate('Y', current_time('timestamp')) ){
			if ( in_array($day, $daywithpost) ) { // any posts today? 
				$calendar_output .= '<td id="today" class="dwp">';
			}
			else {
				$calendar_output .= '<td id="today">';
			}
		}
		else {
			$calendar_output .= "<td{$dwp_class}>";
		}
		
		if ( in_array($day, $daywithpost) ) { // any posts today? 
			$calendar_output .= '<span class="posts_today">' . "$day".'<span class="mb_popup"><span class="ev-popupcontent"><span class="tooltip_arrow"></span>' . $ak_titles_for_day[$day] . '</span><span class="ev-popupbottom"></span></span></span>';
		}
		else {
			$calendar_output .= $day;
		}
		
		$calendar_output .= '</td>';

		if ( 6 == calendar_week_mod(date('w', mktime(0, 0 , 0, $thismonth, $day, $thisyear))-$week_begins) )
			$newrow = true;
	}

	$pad = 7 - calendar_week_mod(date('w', mktime(0, 0 , 0, $thismonth, $day, $thisyear))-$week_begins);
	if ( $pad != 0 && $pad != 7 )
		$calendar_output .= "\n\t\t".'<td class="pad" colspan="'. esc_attr($pad) .'">&nbsp;</td>';

	$calendar_output .= "\n\t</tr>\n\t</tbody>\n\t</table>";
	$calendar_output .= "\n</div> <!-- end custom-calendar -->";
	
	$calendar_output .= "\n" . '</div> <!-- #mb_custom_calendar -->';

	$cache[ $key ] = $calendar_output;
	$et_result = wp_cache_set( 'mb_get_calendar', $cache, 'calendar' );

	if ( $echo )
		echo apply_filters( 'mb_get_calendar',  $calendar_output );
	else
		return apply_filters( 'mb_get_calendar',  $calendar_output );

}
if( !is_admin()){
	wp_deregister_script('jquery');
	wp_register_script('jquery', ("http://ajax.googleapis.com/ajax/libs/jquery/1.7.2/jquery.min.js"), false, '1.7.2');
	wp_enqueue_script('jquery');
}


function fix_category_pagination($qs){	
	$paged = (get_query_var('paged')) ? get_query_var('paged') : 1;
	if(isset($qs['s'])){
		$qs['showposts'] = get_option('posts_per_page');
	}else{
		$qs['showposts'] = $paged;
	}
	return $qs;
}
if(!is_admin()){
	add_filter('request', 'fix_category_pagination');
	add_action('template_redirect','download_redirect');
}

function download_redirect() {
	global $wp;
	if(isset($_GET['mbdlfile']) && $_GET['mbdlfile'] != '' && $wp->query_vars["post_type"] == "album"){
		$filename = end(explode('/',$_GET['mbdlfile']));
		$fp = parse_url($_GET['mbdlfile']);
		$filepath = $_SERVER['DOCUMENT_ROOT'] . $fp['path'];
		if (file_exists($filepath)) {
		    header('Content-Description: File Transfer');
		    header('Content-Type: application/octet-stream');
		    header('Content-Disposition: attachment; filename='.basename($filename));
		    header('Content-Transfer-Encoding: binary');
		    header('Expires: 0');
		    header('Cache-Control: must-revalidate');
		    header('Pragma: public');
		    header('Content-Length: ' . filesize($filepath));
		    ob_clean();
		    flush();
		    readfile($filepath);
		    exit;
		}
	}
}
?>