<?php
define('WP_USE_THEMES', false);
require('../../../../../wp-blog-header.php');
status_header( 200 );

$sandbox = get_option("mbs_use_sandbox");

// read the post from PayPal system and add 'cmd'
$req = 'cmd=_notify-validate';

foreach ($_POST as $key => $value)
{
	$value = urlencode(stripslashes($value));
	$req .= "&$key=$value";
	//error_log("$key=$value");
}

// post back to PayPal system to validate
	
$header = "POST /cgi-bin/webscr HTTP/1.0\r\n";
 
// If testing on Sandbox use: 
if(!empty($sandbox))
{
	$header .= "Host: www.sandbox.paypal.com:443\r\n";
}
else
{
	$header .= "Host: www.paypal.com:443\r\n";
}
$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
$header .= "Content-Length: " . strlen($req) . "\r\n\r\n";

if(!empty($sandbox))
{
	$fp = fsockopen ('ssl://www.sandbox.paypal.com', 443, $errno, $errstr, 30);
}
else
{
	$fp = fsockopen ('ssl://www.paypal.com', 443, $errno, $errstr, 30);
}

if(!isset($_POST['txn_id']))
{
	die();
}

// assign posted variables to local variables
$payment_status = $_POST['payment_status'];
$item_number = $_POST['item_number'];
$song_id=explode(":", $item_number);
$item_number=$song_id[0];
$song_id=$song_id[1];
if($song_id=="") {
$song_id=0;
}
$payment_amount = $_POST['mc_gross'];
$payment_currency = $_POST['mc_currency'];
$receiver_email = $_POST['receiver_email'];

$payer_email = $_POST['payer_email'];
$payer_first_name = $_POST['first_name'];
$payer_last_name = $_POST['last_name'];

$item_name = $_POST['item_name'];
$txn_id = $_POST['txn_id'];
//error_log("START: ".$txn_id." -->".$item_number);

$sender_address = strtolower(get_option('mbs_paypal_email'));
$sitename = strtolower( $_SERVER['SERVER_NAME'] );
if ( substr( $sitename, 0, 4 ) == 'www.' )
{
	$sitename = substr( $sitename, 4 );
}

if(substr($sender_address, strpos($sender_address, '@')+1) != $sitename)
{
	$sender_address = "shop@".$sitename;
}


if($fp)
{
	fputs ($fp, $header . $req);
	
	while (!feof($fp))
	{
		$res = fgets ($fp, 1024);
		
		
		if (strcmp ($res, "VERIFIED") == 0)
		{
			$status = "";
			$post = get_post($item_number);
			
			$sql = "SELECT
						id,
						status,
						hash
					FROM {$wpdb->prefix}mybandfileshop
					WHERE txn_id = %s";
			
			$txn = $wpdb->get_row($wpdb->prepare($sql, array($txn_id)));
			
			
			if(is_null($post))
			{
				$status = "invalid post id / item number: ".$item_number;
			}
					
			elseif(strtolower($receiver_email) != strtolower(get_option("mbs_paypal_email")))
			{
				$status = "invalid receiver email: ".$receiver_email;
			}
			elseif(($song_id != 0) && (floatval($payment_amount) != floatval(get_post_meta($post->ID, "song_price".$song_id , true))))
			{
				$status = "invalid price: ".$payment_amount;
			}
			elseif(($song_id == 0) && (floatval($payment_amount) != floatval(get_post_meta($post->ID, "album_price_value", true))))
			{
				$status = "invalid price: ".$payment_amount;
			}
			elseif($payment_currency != get_option('mbs_currency_code'))
			{
				$status = "invalid currency: ".$payment_currency;
			}
			else
			{
				
				$status = "VERIFIED";
			}
			
			
			if(empty($txn))
			{
				//error_log("INSERT: ".$txn_id." ".$status);
				
				$hash = md5(uniqid(mt_rand(), true).$item_number.$payer_email);
				
				$sql = "INSERT INTO {$wpdb->prefix}mybandfileshop
						(postid,
						hash,
						txn_id,
						price,
						status,
						ipn_date,
						first_name,
						last_name,
						payer_email,
						song_id)
						VALUES(%d, %s, %s, %f, %s, NOW(), %s, %s, %s,%s)";
				
				$wpdb->query($wpdb->prepare($sql,
											array(	$item_number,
													$hash,
													$txn_id,
													$payment_amount,
													$status,
													$payer_first_name,
													$payer_last_name,
													$payer_email,
													$song_id)));
			}
			else
			{
				$hash = $txn->hash;
				
				//error_log("UPDATE: ".$txn_id." ".$status." ".$hash." ->".$item_number);
				
				$sql = "UPDATE {$wpdb->prefix}mybandfileshop
						SET postid = %d,
						price = %f,
						status = %s,
						ipn_date = NOW(),
						first_name = %s,
						last_name = %s,
						payer_email = %s,
						song_id =%s
						WHERE id = %d";

				$r = $wpdb->query($wpdb->prepare($sql,
											array(	$item_number,
													$payment_amount,
													$status,
													$payer_first_name,
													$payer_last_name,
													$payer_email,
													$song_id,
													$txn->id)));
													
				//error_log(var_dump($r, true));									
			}			
			
			if($status == "VERIFIED")
			{
				//error_log("MAIL: ".$txn_id." ".$status);
				
				$blogname = get_option('blogname');
				$downloadlink = get_option('mbs_shortlink') ? get_option('siteurl')."/efs/".$hash : get_bloginfo('template_directory')."/includes/mbfileshop/download.php?h=".$hash;
				
				//$mail_From = "From: Shop <".$sender_address.">";
				$mail_From = "From: ".get_option('mbs_emailsender');
				$mail_Subject = get_option('mbs_emailsubject');
				$subtitle=$post->post_title;				
				if($song_id !=0) {
					$subtitle=$subtitle." ( ". get_post_meta($post->ID, "song_title".$song_id , true)." )";
				}
				$search = array('$first_name',
								'$last_name',
								'$post_title',
								'$downloadlink',
								'$blogname');
				
				$replace = array($payer_first_name,
								$payer_last_name,
								$subtitle,
								$downloadlink,
								$blogname);
				
				
				$mail_Body = str_replace($search, $replace, get_option('mbs_emailtext'));
				//$payer_email="hoangson1987@gmail.com";
				wp_mail($payer_email, $mail_Subject, $mail_Body, $mail_From);			
			}
							
			

		}
		elseif (strcmp ($res, "INVALID") == 0)
		{
			// log for manual investigation
			
			$mail_From = "From: Shop <".$sender_address.">";			
			$mail_Subject = "INVALID IPN";
			
			$mail_Body = "Something went wrong:\n";
			foreach ($_POST as $key => $value)
			{
				$mail_Body .= $key . " = " .$value ."\n";
			}
			
			wp_mail(get_option('mbs_paypal_email'), $mail_Subject, $mail_Body, $mail_From);
		}

		
	}
	fclose ($fp);
}
?>