<?php
/*
Plugin Name: mybandfileshop
Plugin URI: http://www.mybandtheme.com
Description: mybandfileshop enables you to sell files as downloads.
Author: Evolve Digital Creations
Version: 1.3.0
Author URI: http://www.mybandtheme.com
*/

//error_reporting(E_ALL);
//ini_set('display_errors', 1);
define("MBS_FILE_PERMISSIONS", 0666);
define("MBS_DIR", WP_CONTENT_DIR."/mybandfileshop");

/**
 *
 * @desc registers a theme activation hook
 * @param string $code : Code of the theme. This can be the base folder of your theme. Eg if your theme is in folder 'mytheme' then code will be 'mytheme'
 * @param callback $function : Function to call when theme gets activated.
 */
function wp_register_theme_activation_hook($code, $function) {
    $optionKey="theme_is_activated_" . $code;
    if(!get_option($optionKey)) {
        call_user_func($function);
        update_option($optionKey , 1);
    }
}

/**
 * @desc registers deactivation hook
 * @param string $code : Code of the theme. This must match the value you provided in wp_register_theme_activation_hook function as $code
 * @param callback $function : Function to call when theme gets deactivated.
 */
function wp_register_theme_deactivation_hook($code, $function) {
    // store function in code specific global
    $GLOBALS["wp_register_theme_deactivation_hook_function" . $code]=$function;

    // create a runtime function which will delete the option set while activation of this theme and will call deactivation function provided in $function
    $fn=create_function('$theme', ' call_user_func($GLOBALS["wp_register_theme_deactivation_hook_function' . $code . '"]); delete_option("theme_is_activated_' . $code. '");');

    // add above created function to switch_theme action hook. This hook gets called when admin changes the theme.
    // Due to wordpress core implementation this hook can only be received by currently active theme (which is going to be deactivated as admin has chosen another one.
    // Your theme can perceive this hook as a deactivation hook.
    add_action("switch_theme", $fn);
}



$mbs_currency_codes = array("EUR" => "Euros (€)", 
							"USD" => "U.S. Dollars ($)",
							"AUD" => "Australian Dollars (A $)",
							"CAD" => "Canadian Dollars (C $)", 	
							"GBP" => "Pounds Sterling (£)", 	
							"JPY" => "Yen (¥)", 	
							"NZD" => "New Zealand Dollar ($)", 	
							"CHF" => "Swiss Franc", 	
							"HKD" => "Hong Kong Dollar ($)", 	
							"SGD" => "Singapore Dollar ($)", 	
							"SEK" => "Swedish Krona", 	
							"DKK" => "Danish Krone", 	
							"PLN" => "Polish Zloty", 	
							"NOK" => "Norwegian Krone", 	
							"HUF" => "Hungarian Forint", 	
							"CZK" => "Czech Koruna", 	
							"ILS" => "Israeli Shekel", 	
							"MXN" => "Mexican Peso", 	
							"BRL" => "Brazilian Real (only for Brazilian users)", 	
							"MYR" => "Malaysian Ringgits (only for Malaysian users)", 	
							"PHP" => "Philippine Pesos", 	
							"TWD" => "Taiwan New Dollars", 	
							"THB" => "Thai Baht");

//add_action('admin_menu', 'mbs_meta_box');
//add_action('save_post', 'mbs_save_meta', 100, 2);
add_shortcode('mybandfileshop', 'mybandfileshop_shortcode');
wp_register_theme_activation_hook('myband','mbs_install');
add_action( 'admin_init', 'mbs_register_mysettings' );
add_action('admin_menu', 'mbs_add_pages');
//add_action('admin_init','mbs_admin_head');
//wp_register_theme_deactivation_hook('myband','mbs_uninstall');

function mybandfileshop_shortcode($atts)
{
	global $post;
	
	extract(shortcode_atts(array('id' => null), $atts));
	
	if(is_null($id) AND !is_null($post))
	{
		return mybandfileshop_output($post->ID);
	}
	elseif(!is_null($id))
	{
		return mybandfileshop_output($id);
	}
	else
	{
		return "";
	}
	
}

function mybandfileshop($id = null)
{
	global $post;
	
	if(is_null($id) AND !is_null($post))
	{
		echo mybandfileshop_output($post->ID);
	}
	elseif(!is_null($id))
	{
		echo mybandfileshop_output($id);
	}
	else
	{
		echo "";
	}
}

function mybandfileshop_output($postid)
{
	$post = get_post($postid);
	
	$price = get_post_meta($post->ID, "mbs_price", true);
	$currency = get_option('mbs_currency_code');
	$use_sandbox = get_option('mbs_use_sandbox');
	$email = get_option('mbs_paypal_email');
	
	ob_start();
	
	if(	!empty($price)
		AND !empty($currency)
		AND count(mbs_glob(MBS_DIR."/post".$post->ID."_*"))
		AND !empty($email)) 
	{
		echo "<form action='".(empty($use_sandbox) ? "https://www.paypal.com/cgi-bin/webscr" : "https://www.sandbox.paypal.com/cgi-bin/webscr")."' method='post' target='_blank'>";
		$price = sprintf("%01.2f", $price);
		
		if(file_exists(MBS_DIR."/button.php"))
		{
			include(MBS_DIR."/button.php");
		}
		else
		{
			include("button.php");
		}

		echo '<input type="hidden" name="cmd" value="_xclick" />';
		echo "<input type='hidden' name='business' value='$email' />";
		echo "<input type='hidden' name='item_name' value='".esc_attr($post->post_title)."' />";
		echo "<input type='hidden' name='item_number' value='$post->ID' />";
		echo "<input type='hidden' name='amount' value='$price' />";
		echo '<input type="hidden" name="no_shipping" value="1" />';
		echo '<input type="hidden" name="no_note" value="1" />';
		echo "<input type='hidden' name='currency_code' value='$currency' />";
		echo "<input type='hidden' name='notify_url' value='".get_option('siteurl')."/wp-content/plugins/mybandfileshop/ipn.php' />";
		$mbs_return_page = get_option('mbs_return_page');
		if(!empty($mbs_return_page))
		{
			echo "<input type='hidden' name='return' value='".get_page_link($mbs_return_page)."' />";
		}
		echo '</form>';
	}
	return ob_get_clean();
}

function mybandfileshop_single_output($postid,$price,$itemName="",$subid="",$album=false)
{
	$mbs_currency_codes_char = array("EUR" => "€", 
							"USD" => "$",
							"AUD" => "A $",
							"CAD" => "C $", 	
							"GBP" => "£", 	
							"JPY" => "¥", 	
							"NZD" => "$", 	
							"HKD" => "$", 	
							"SGD" => "$");
	$post = get_post($postid);
	$item_id=$post->ID.":".$subid;
	if($itemName=="") {
		$itemName = esc_attr($post->post_title);
	}
	$currency = get_option('mbs_currency_code');
	$currency2=$currency;
	if($mbs_currency_codes_char[$currency] !="") {
		$currency2=$mbs_currency_codes_char[$currency];
	}
	
	$use_sandbox = get_option('mbs_use_sandbox');
	$email = get_option('mbs_paypal_email');
	
	
	if(	!empty($price)
		AND !empty($currency)
		AND !empty($email)) 
	{
		$output = "<form action='".(empty($use_sandbox) ? "https://www.paypal.com/cgi-bin/webscr" : "https://www.sandbox.paypal.com/cgi-bin/webscr")."' method='post' target='_blank'>";
		$price = sprintf("%01.2f", $price);
		if($album==true )
		{
			if($currency2=='€') {
			$currency2="<img style='position: relative;top: 4px;' src='".get_bloginfo('template_directory')."/images/auro-icon.png' alt='price'/>";
			}
			$output .= '<div class="price-text">'.__('Buy Album','myband').'</div><div class="price-box"><div class="price-box-inner1"><div class="price-box-inner2">'.$currency2. ' '. $price .'</div></div></div><input class="button-submit" type="submit" border="0" name="submit" value="" />';
		}
		else 
		{
			$output .= "<div><input type='submit' border='0' name='submit' value='".__('Buy','myband').' '.$currency2.$price."'></div>";
		}

		$output .= '<input type="hidden" name="cmd" value="_xclick" />';
		$output .= "<input type='hidden' name='business' value='$email' />";
		$output .= "<input type='hidden' name='item_name' value='".$itemName."' />";
		$output .= "<input type='hidden' name='item_number' value='$item_id' />";
		$output .= "<input type='hidden' name='amount' value='$price' />";
		$output .= '<input type="hidden" name="no_shipping" value="1" />';
		$output .= '<input type="hidden" name="no_note" value="1" />';
		$output .= "<input type='hidden' name='currency_code' value='$currency' />";
		$output .= "<input type='hidden' name='notify_url' value='".get_bloginfo('template_directory')."/includes/mbfileshop/ipn.php' />";
		$mbs_return_page = get_option('mbs_return_page');
		if(!empty($mbs_return_page))
		{
			$output .= "<input type='hidden' name='return' value='".get_permalink($mbs_return_page)."' />";
		}
		$output .= '</form>';
	}
	return $output;
}

function mybandfileshop_external_output($albumURL, $provider)
{
	switch($provider){
		case 'itunes':
			$output = "<a href='".$albumURL."' target='_blank'><div class='price-text'>Buy Album </div><div class='price-box2'><div class='price-box-inner1'><div class='price-box-inner2'>on iTunes</div></div></div></a>";
		break;
		
		case 'amazon':
			$output = "<a href='".$albumURL."' target='_blank'><div class='price-text'>Buy Album </div><div class='price-box2'><div class='price-box-inner1'><div class='price-box-inner2'>on Amazon MP3</div></div></div></a>";			
		break;
	}
	return $output;
}


function mbs_meta_box()
{
    add_meta_box( 'mbs_meta', 'mybandfileshop', 'mbs_metabox_content', 'post');
    add_meta_box( 'mbs_meta', 'mybandfileshop', 'mbs_metabox_content', 'page');
}

function mbs_metabox_content() {
	global $post;
	
	$currency_code = get_option('mbs_currency_code');
	
	if(empty($currency_code))
	{
		echo "<p class='error'>Please select currency on settings page first.</p>";
		return;
	}
	
	if(!mbs_check_dir())
	{
	    echo "<p class='error'>";
	    echo "Please create a directory ".MBS_DIR." and make it writeable (chmod 777 or less).";
	    echo "</p>";
	    return;
	}	
	?>
	<script type="text/javascript">
		document.getElementById("post").setAttribute("enctype","multipart/form-data");
		document.getElementById('post').setAttribute('encoding','multipart/form-data');

		jQuery(document).ready(function() {
			jQuery('#mbs_deletelink').click(function(e){
				e.preventDefault();
				jQuery('#mbs_delete').val(1);
				jQuery('#post').submit();
			});
		});
	</script>
	<?php
	echo "<table class='form-table'>";
	echo "<tbody>";
	
	$files = mbs_glob(MBS_DIR."/post".$post->ID."_*");
	if(count($files))
	{
		echo "<tr>";
		echo "<td>";
		echo "<label for='mbs_file'><strong>File to sell</strong></label>";
		echo "</td>";
		echo "<td>";
		echo "<strong>".array_pop(explode("/",$files[0]))."</strong> (<a href='#' id='mbs_deletelink'>delete</a>)";
		echo "</td>";
		echo "</tr>";
	}
	echo "<tr>";
	echo "<td>";
	echo '<label for="mbs_file"><strong>'."Upload new file".'</strong></label>';
	echo "</td>";
	echo "<td>";
	echo "<input type='file' name='mbs_file' id='mbs_file' class='regular-text' />";
	echo "</td>";
	echo "</tr>";
	
	echo "<tr>";
	echo "<td>";
	echo "<label for='mbs_price'><strong>Price in $currency_code</strong></label>";
	echo "</td>";
	echo "<td>";
	$price = get_post_meta($post->ID, 'mbs_price', true);
	$price = empty($price) ? "" : sprintf("%01.2f", $price);
	echo "<input type='text' name='mbs_price' id='mbs_price' value='".$price."' class='regular-text' />";
	echo "</td>";
	echo "</tr>";	

	echo "<tr>";
	echo "<td>";
	echo "</td>";
	echo "<td>";
	echo "<input type='hidden' name='mbs_delete' id='mbs_delete' value='0' />";
	echo "<input name='publish' class='button-primary' type='submit' value='Update Post' />";
	echo "</td>";
	echo "</tr>";	
	
	echo "</tbody>";
	echo "</table>";
	
	echo "<p>";
	echo "<strong>Don't forget:</strong> You need to add the shortcode [mybandfileshop] into the HTML of this post.<br />";
	echo "Did you know, you can customize the button and use it somewhere else? See <a href='http://www.felixkoch.de/mybandfileshop/customization/'>Customization</a> and <a href='http://www.felixkoch.de/mybandfileshop/usage/'>Usage</a>.";
	echo "</p>";
}



function mbs_save_meta($post_id, $post)
{
	
	if ($post->post_type == 'revision')
	{
		return;
	}
		
	if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE)
	{
		return $post_id;
	}
	
	
	
	$_POST['mbs_price'] = floatval(strtr(@$_POST['mbs_price'], ',', '.'));
	if(empty($_POST['mbs_price']))
	{
		$_POST['mbs_price'] = "";
	}
	else
	{
		$_POST['mbs_price'] = sprintf("%01.2f", $_POST['mbs_price']);
	}
	
	//error_log($_POST['mbs_price']);
	
	if(get_post_meta($post_id, 'mbs_price') == "" AND $_POST['mbs_price'] != "")
	{ 
		add_post_meta($post_id, 'mbs_price', $_POST['mbs_price'], true);  
	}
	elseif($_POST['mbs_price'] != get_post_meta($post_id, 'mbs_price', true) AND $_POST['mbs_price'] != "")
	{  
		update_post_meta($post_id, 'mbs_price', $_POST['mbs_price']);  
	}
	elseif($_POST['mbs_price'] == "")
	{  
		delete_post_meta($post_id, 'mbs_price');
	}  
	
	if(!empty($_POST['mbs_delete']))
	{
		$files = mbs_glob(MBS_DIR."/post".$post_id."_*");
		foreach($files as $file)
		{
			if(is_file($file))
			{
				unlink($file);
			}
		}
	}
	
	if(isset($_FILES['mbs_file']) AND $_FILES['mbs_file']['error'] == 0)
	{
		$files = mbs_glob(MBS_DIR."/post".$post_id."_*");
		foreach($files as $file)
		{
			if(is_file($file))
			{
				unlink($file);
			}
		}
		
		$destination = MBS_DIR."/post".$post_id."_".sanitize_file_name($_FILES['mbs_file']['name']);
		@move_uploaded_file( $_FILES['mbs_file']['tmp_name'], $destination);
		@chmod($destination, MBS_FILE_PERMISSIONS);
	
	}
	
}

function mbs_glob($pattern)
{
	return glob($pattern) ? glob($pattern) : array();
}


function mbs_install ()
{
	global $wpdb;
	$mbs_db_version = 1.4;
	
	$table_name = $wpdb->prefix . "mybandfileshop";
   
	
	if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name)
	{
      
		$sql = "CREATE TABLE " . $table_name . "  (
				`id` BIGINT( 20 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
				`postid` BIGINT( 20 ) NOT NULL ,
				`hash` VARCHAR( 255 ) NOT NULL ,
				`txn_id` VARCHAR( 255 ) NOT NULL ,
				`price` FLOAT( 10, 2 ) NOT NULL ,
				`status` VARCHAR( 255 ) NOT NULL ,
				`ipn_date` DATETIME NOT NULL ,
				`first_name` VARCHAR( 255 ) NOT NULL ,
				`last_name` VARCHAR( 255 ) NOT NULL ,
				`payer_email` VARCHAR( 255 ) NOT NULL ,
				`downloads` INT( 11 ) NOT NULL DEFAULT '0' ,
				`last_download` DATETIME NULL,
				`song_id` INT( 11 ) NULL DEFAULT '0'	
				) CHARACTER SET utf8 COLLATE utf8_unicode_ci;";

		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		dbDelta($sql);
 
		add_option("mbs_db_version", $mbs_db_version);

	}

	$installed_ver = get_option( "mbs_db_version" );
	
	if( $installed_ver != $mbs_db_version )
	{
	
		$sql = "CREATE TABLE " . $table_name . "  (
				`id` BIGINT( 20 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
				`postid` BIGINT( 20 ) NOT NULL ,
				`hash` VARCHAR( 255 ) NOT NULL ,
				`txn_id` VARCHAR( 255 ) NOT NULL ,
				`status` VARCHAR( 255 ) NOT NULL ,
				`price` FLOAT( 10, 2 ) NOT NULL ,
				`status` VARCHAR( 255 ) NOT NULL ,
				`ipn_date` DATETIME NOT NULL ,
				`first_name` VARCHAR( 255 ) NOT NULL ,
				`last_name` VARCHAR( 255 ) NOT NULL ,
				`payer_email` VARCHAR( 255 ) NOT NULL ,
				`downloads` INT( 11 ) NOT NULL DEFAULT '0' ,
				`last_download` DATETIME NULL ,
				`song_id` INT( 11 ) NULL DEFAULT '0'
				) CHARACTER SET utf8 COLLATE utf8_unicode_ci;";
	
		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		dbDelta($sql);
			
		update_option( "mbs_db_version", $mbs_db_version );
	}
	
}

function mbs_register_mysettings()
{
	register_setting( 'mbs-settings-group', 'mbs_currency_code' );
	register_setting( 'mbs-settings-group', 'mbs_paypal_email', 'sanitize_email');
	register_setting( 'mbs-settings-group', 'mbs_max_download' );
	register_setting( 'mbs-settings-group', 'mbs_expire_link' );
	register_setting( 'mbs-settings-group', 'mbs_use_sandbox' );
	register_setting( 'mbs-settings-group', 'mbs_emailsubject' );
	register_setting( 'mbs-settings-group', 'mbs_emailsender' );
	register_setting( 'mbs-settings-group', 'mbs_emailtext' );
	register_setting( 'mbs-settings-group', 'mbs_shortlink' );
	register_setting( 'mbs-settings-group', 'mbs_return_page' );
	register_setting( 'mbs-settings-group', 'mbs_maxdl_page' );
}


function mbs_add_pages()
{
    add_menu_page("mybandfileshop", "MyBand shop", 'manage_options', 'mbs-top-level-handle', 'mbs_sales_page',get_bloginfo('template_directory').'/images/admin-shop-icon.png' );
    add_submenu_page('mbs-top-level-handle', 'Settings', 'Settings', 'manage_options', 'mbs-settings-page', 'mbs_settings_page');
}

function mbs_sales_page()
{
	global $wpdb;
	$mybandfileshop = $wpdb->prefix."mybandfileshop";
	
	if(isset($_POST['reset_dl'])){
		$trid = $_POST['transID'];		
		$sql_trdlrs = "UPDATE $mybandfileshop
				SET downloads = '0'
				WHERE id = $trid";

		$r = $wpdb->query($sql_trdlrs);
	}
	echo "<div class='wrap'>";
    echo "<h2>Sales</h2>";
    
	   
    
	echo "<h3>Search Transaction</h3>";
	echo '<script type="text/javascript">
			jQuery(document).ready(function() {
				jQuery( "#min_date" ).datepicker({ dateFormat: "dd-M-yy" });
				jQuery( "#max_date" ).datepicker({ dateFormat: "dd-M-yy" });
			 });

			
		</script>';
	
	echo "<div id='form-left'><form method='get' action='{$_SERVER['SCRIPT_NAME']}'>";
	echo "<table class='form-table'>";
	echo "<tr valign='top'>";
	echo "<th scope='row'>Name of Payer</th>";
	echo "<td>";
	echo "<input type='text' name='name' value='".@$_GET['name']."' />";
	echo "</td>";
	echo "</tr>";

	echo "<tr valign='top'>";
	echo "<th scope='row'>Email of Payer</th>";
	echo "<td>";
	echo "<input type='text' name='email' value='".@$_GET['email']."' />";
	echo "</td>";
	echo "</tr>";
	
	echo "<tr valign='top'>";
	echo "<th scope='row'>Title of Post/File</th>";
	echo "<td>";
	echo "<input type='text' name='title' value='".@$_GET['title']."' />";
	echo "</td>";
	echo "</tr>";

	echo "<tr valign='top'>";
	echo "<th scope='row'>Post / Product ID</th>";
	echo "<td>";
	echo "<input type='text' name='postid' value='".@$_GET['postid']."' />";
	echo "</td>";
	echo "</tr>";	
	
	echo "<tr valign='top'>";
	echo "<th scope='row'>Paypal Transaction ID</th>";
	echo "<td>";
	echo "<input type='text' name='txn_id' value='".@$_GET['txn_id']."' />";
	echo "</td>";
	echo "</tr>";

	echo "<tr valign='top'>";
	echo "<th scope='row'>Presets of payment</th>";
	echo "<td>";
	echo "<select name='presets'>";
	$selected = (isset($_GET['presets']) AND $_GET['presets'] == 0) ? "selected='selected'" : "";
	echo "<option value='0' $selected>All time</option>";
	$selected = (isset($_GET['presets']) AND $_GET['presets'] == 1) ? "selected='selected'" : "";
	echo "<option value='1' $selected>Today</option>";
	$selected = (isset($_GET['presets']) AND $_GET['presets'] == 2) ? "selected='selected'" : "";
	echo "<option value='2' $selected>This weeks</option>";
	$selected = (isset($_GET['presets']) AND $_GET['presets'] == 3) ? "selected='selected'" : "";
	echo "<option value='3' $selected>This month</option>";
	$selected = (isset($_GET['presets']) AND $_GET['presets'] == 4) ? "selected='selected'" : "";
	echo "<option value='4' $selected>This year</option>";
	echo "</select>";
	echo "</td>";
	echo "</tr>";
	
	echo "<tr valign='top'>";
	echo "<th scope='row'>Minimum date</th>";
	echo "<td>";
	echo "<input type='text' id='min_date' readonly='true' name='min_date' value='".@$_GET['min_date']."' />";
	echo "</td>";
	echo "</tr>";

	echo "<tr valign='top'>";
	echo "<th scope='row'>Maxium date</th>";
	echo "<td>";
	echo "<input type='text' id='max_date' readonly='true' name='max_date' value='".@$_GET['max_date']."' />";
	echo "</td>";
	echo "</tr>";	

	echo "<tr valign='top'>";
	echo "<th scope='row'>Status of payment</th>";
	echo "<td>";
	echo "<select name='status'>";
	$selected = (isset($_GET['status']) AND $_GET['status'] == 0) ? "selected='selected'" : "";
	echo "<option value='0' $selected>All</option>";
	$selected = (isset($_GET['status']) AND $_GET['status'] == 1) ? "selected='selected'" : "";
	echo "<option value='1' $selected>Only VERIFIED</option>";
	$selected = (isset($_GET['status']) AND $_GET['status'] == 2) ? "selected='selected'" : "";
	echo "<option value='2' $selected>Only Invalid</option>";
	echo "</select>";
	echo "</td>";
	echo "</tr>";	
	
	echo "</table>";
	echo "<p class='submit'>";
	echo "<input type='hidden' name='page' value='mbs-top-level-handle' />";
	echo "<input type='submit' class='button-secondary' value='Search Transactions' />";
	echo "</p>";
	
	echo "</form></div>";
	
	?>
		<div id="form-right">
			<div id="chart1" class="plot" style="width:600px;height:400px;"></div>
	
		</div>
		<div class="clear"></div>
	<?php
	
	foreach($_GET as $key => $value)
	{
		$_GET[$key] = trim($value);
	}
	
	$nameBedingung = "";
	if(!empty($_GET['name']))
	{
		$nameBedingung = " AND (first_name LIKE '%".$wpdb->escape($_GET['name'])."%' OR last_name LIKE '%".$wpdb->escape($_GET['name'])."%') ";
	}
	
	
	$emailBedingung = "";
	if(!empty($_GET['email']))
	{
		$emailBedingung = " AND payer_email LIKE '%".$wpdb->escape($_GET['email'])."%' ";
	}
	
	$titleBedingung = "";
	if(!empty($_GET['title']))
	{
		$titleBedingung = " AND post_title LIKE '%".$wpdb->escape($_GET['title'])."%' ";
	}	
	
	$titleBedingung = "";
	if(!empty($_GET['title']))
	{
		$titleBedingung = " AND post_title LIKE '%".$wpdb->escape($_GET['title'])."%' ";
	}
	
	$postidBedingung = "";
	if(!empty($_GET['postid']))
	{
		$postidBedingung = " AND postid = ".intval($_GET['postid'])." ";
	}

	$txn_idBedingung = "";
	if(!empty($_GET['txn_id']))
	{
		$txn_idBedingung = " AND txn_id = '".$wpdb->escape($_GET['txn_id'])."' ";
	}

	$presetsBedingung = "";
	if(!empty($_GET['presets']))
	{
		$selectPresets=$_GET['presets'];
		if($selectPresets==1) {
			$presetsBedingung = " AND DATE(ipn_date) = CURDATE() ";
		}
		if($selectPresets==2) {
			$presetsBedingung = " AND WEEK(ipn_date) = WEEK(CURDATE()) ";
		}
		if($selectPresets==3) {
			$presetsBedingung = " AND MONTH(DATE(ipn_date)) = MONTH(CURDATE()) ";
		}
		if($selectPresets==4) {
			$presetsBedingung = " AND YEAR(DATE(ipn_date)) = YEAR(CURDATE()) ";
		}
	}
	
	$mindateBedingung="";
	if(!empty($_GET['min_date']))
	{
		$mindateBedingung = " AND DATE(ipn_date) >= DATE(STR_TO_DATE('".$wpdb->escape($_GET['min_date'])."','%d-%b-%Y')) ";
	}
	$maxdateBedingung="";
	if(!empty($_GET['max_date']))
	{
		$maxdateBedingung = " AND DATE(ipn_date) <= DATE(STR_TO_DATE('".$wpdb->escape($_GET['max_date'])."','%d-%b-%Y')) ";
	}
	
	$statusBedingung = "";
	if(!empty($_GET['status']))
	{
		$operator = $_GET['status'] == 1 ? "=" : "!=";
		$statusBedingung = " AND status $operator 'VERIFIED' ";
	}
		
	$current = empty($_GET['paged']) ? 1 : intval($_GET['paged']);
	$items_per_page = 50;
	
//	$mybandfileshop = $wpdb->prefix."mybandfileshop";

	$sql = "SELECT SQL_CALC_FOUND_ROWS
				$mybandfileshop.*,DATE($mybandfileshop.ipn_date) as date_tran, 
				{$wpdb->posts}.post_title
			FROM
				$mybandfileshop
			LEFT JOIN {$wpdb->posts} ON $mybandfileshop.postid = {$wpdb->posts}.ID
			WHERE TRUE
			$nameBedingung
			$emailBedingung
			$titleBedingung
			$postidBedingung
			$txn_idBedingung
			$presetsBedingung
			$mindateBedingung
			$maxdateBedingung
			$statusBedingung
			ORDER BY id DESC
			LIMIT ".(($current-1)*$items_per_page).", ".$items_per_page;
	
	//echo $sql;			
				
	$rows = $wpdb->get_results($sql);

	$found_rows = $wpdb->get_col("SELECT FOUND_ROWS();");
		
	$items = $found_rows[0];
	
	if($items > 0)
	{
	
		$items_per_page = 50;
		$num_pages = ceil($items / $items_per_page);
		
			
		$page_links = paginate_links( array(
			'base' => add_query_arg( 'paged', '%#%' ),
			'format' => '',
			'prev_text' => __('&laquo;'),
			'next_text' => __('&raquo;'),
			'total' => $num_pages,
			'current' => $current
		));
		
		echo "<h3>$items Transactions found</h3>";
		
		echo "<div class='tablenav'>";
		echo "<div class='tablenav-pages'>";
		echo $page_links; 
		echo "</div>";
		echo "</div>";

	
		echo "<table class='widefat'>";
		echo "<thead>";
		echo "<tr>";
		echo "<th>Transaction ID</th>";
		echo "<th>Post ID</th>";
		echo "<th>Post Title</th>";
		echo "<th>Price</th>";
		echo "<th>Status</th>";
		echo "<th>Date</th>";
		echo "<th>First name</th>";
		echo "<th>Last name</th>";
		echo "<th>Payer email</th>";
		echo "<th>Link</th>";
		echo "<th>Downloads</th>";
		echo "<th>Last Download</th>";
		echo "<th>Reset Downloads</th>";
		echo "</tr>";
		echo "</thead>";
		echo "<tfoot>";
		echo "<tr>";
		echo "<th>Transaction ID</th>";
		echo "<th>Post ID</th>";
		echo "<th>Post Title</th>";
		echo "<th>Price</th>";
		echo "<th>Status</th>";
		echo "<th>Date</th>";
		echo "<th>First name</th>";
		echo "<th>Last name</th>";
		echo "<th>Payer email</th>";
		echo "<th>Link</th>";
		echo "<th>Downloads</th>";
		echo "<th>Last Download</th>";
		echo "<th>Reset Downloads</th>";
		echo "</tr>";
		echo "</tfoot>";
		echo "<tbody>";
		$arrSale = array();
		$arrMoney= array();
		$arrDate =array();
		$index=0;
		foreach($rows as $row)
		{
			if (!in_array($row->date_tran, $arrDate)) {
			   $arrDate[]=$row->date_tran;
			   $query_date="SELECT SUM(price) AS total,COUNT(postid) AS countSale FROM $mybandfileshop WHERE DATE($mybandfileshop.ipn_date) ='".$row->date_tran."'";
			  // echo $query_date;exit;
			   $results=$wpdb->get_results($query_date, OBJECT);
			   foreach($results as $result) {
					$arrSale[$index]="['".$row->date_tran."',".$result->countSale."]";
					$arrMoney[$index]="['".$row->date_tran."',".$result->total."]";
			   }
			   $index++;
			   
			}
			echo "<form action=\"\" method=\"post\"><tr>";
			echo "<td>{$row->txn_id}</td>";
			echo "<td><a href='".get_page_link($row->postid)."' target='_blank'>{$row->postid}</a></td>";
			if($row->song_id !=0){
				$row->post_title =$row->post_title .'( '.get_post_meta($row->postid, "song_title".$row->song_id , true).' )';
				echo "<td><a href='".get_page_link($row->postid)."' target='_blank'>{$row->post_title}</a></td>";
			}else {
			echo "<td><a href='".get_page_link($row->postid)."' target='_blank'>{$row->post_title}</a></td>";
			}
			echo "<td>".$row->price." ".get_option('mbs_currency_code')."</td>";
			echo "<td>{$row->status}</td>";
			echo "<td>{$row->ipn_date}</td>";
			echo "<td>{$row->first_name}</td>";
			echo "<td>{$row->last_name}</td>";
			echo "<td><a href='mailto:{$row->payer_email}'>{$row->payer_email}</a></td>";
			
			$link = get_option('mbs_shortlink') ? get_option('siteurl')."/efs/".$row->hash : get_bloginfo('template_directory')."/includes/mbfileshop/download.php?h=".$row->hash;
			echo "<td><a href='$link' target='_blank'>{$row->hash}</a></td>";
			echo "<td>{$row->downloads}</td>";
			echo "<td>{$row->last_download}</td>";
			echo "<td><input class=\"button autowidth\" type=\"submit\" value=\"Reset Downloads\" name=\"reset_dl\"></td>";
			echo "<input type='hidden' value=".$row->id." name='transID' />";
			echo "</tr></form>";
		}
		echo "</tbody>";
		echo "</table>";
		$strMoney="x";
		$strSale="x";
		for($i2=$index-1;$i2 >= 0; $i2--) {
			
				$strSale .= ", ".$arrSale[$i2];
				$strMoney .= ", ".$arrMoney[$i2];
			
			
		} ?>
<script language="javascript" type="text/javascript"><!--

    jQuery.jqplot.config.enablePlugins = true;
    
var line1=[<?php echo str_replace("x,","", $strSale) ;?>];
var line2=[<?php echo str_replace("x,","", $strMoney); ?>];

	
plot1 = jQuery.jqplot('chart1', [line1,line2], {
	stackSeries: true,
    legend: {
        show: true,
        location: 'nw',
        xoffset: 400
    },
    title:'',
	 series:[
        {label: 'Count Sales'}, 
        {yaxis:'y2axis',label: 'Total money'}, 
        {yaxis:'y3axis'}, 
        {yaxis:'y4axis'}, 
        {yaxis:'y5axis'}, 
        {yaxis:'y6axis'}
    ],
    axes:{
        xaxis:{
            renderer:jQuery.jqplot.DateAxisRenderer,
            rendererOptions:{tickRenderer:jQuery.jqplot.CanvasAxisTickRenderer},
            tickOptions:{
                formatString:'%b %#d, %Y', 
                fontSize:'10pt', 
                fontFamily:'Tahoma', 
                angle:-30
            }
        },
		yaxis: {
			autoscale:true
		},
        y2axis:{tickOptions:{formatString:'<?php echo get_option('mbs_currency_code');?> %.2f'},autoscale:true}
		
    },
	
    highlighter: {sizeAdjust: 7.5},
    cursor: {show: false}
});


	

--></script>
		
		
	<?php }

	echo "</div>";


}

function mbs_settings_page()
{
	global $mbs_currency_codes;
	global $wpdb;
	
	if(get_option('mbs_emailsubject') == "")
	{
		update_option('mbs_emailsubject', "Your Download Link");
	}
	if(get_option('mbs_emailsender') == "")
	{
		update_option('mbs_emailsender', "YOUR NAME <your@emailaddress.com>");
	}
	if(get_option('mbs_max_download') == "")
	{
		update_option('mbs_max_download', "3");
	}
	if(get_option('mbs_expire_link') == "")
	{
		update_option('mbs_expire_link', "10");
	}
	if(get_option('mbs_emailtext') == "")
	{
$text = 'Dear $first_name $last_name,

thank you for buying the file $post_title.
You may download it here:
$downloadlink

Kindest regards
$blogname';

		update_option('mbs_emailtext', $text);
	}	
	
	
?>
<div class="wrap">
<h2>MyBand shop settings</h2>
<?php 

?>
<form method="post" action="options.php">
    <?php settings_fields( 'mbs-settings-group' ); ?>
    <table class="form-table">
        <tr valign="top">
        <th scope="row">Currency</th>
        <td>
        <?php
        	echo "<select name='mbs_currency_code'>";
        	foreach($mbs_currency_codes as $code => $currency)
        	{
        		$selected = (get_option('mbs_currency_code') == $code) ? "selected='selected'" : "";
        		echo "<option value='$code' $selected>$currency</option>";	
        	}
        	echo "</select>";
		?>       
        </td>
        </tr>

        <tr valign="top">
        <th scope="row">Your PayPal email</th>
        <td>
		<input type='text' name='mbs_paypal_email' value='<?php echo get_option('mbs_paypal_email'); ?>' />     
        </td>
        </tr>
		<tr valign="top">
        <th scope="row">The maximum number of downloads</th>
        <td>
		<input type='text' name='mbs_max_download' value='<?php echo get_option('mbs_max_download'); ?>' />     
        </td>
        </tr>
		<?php
        echo "<tr valign='top'>";
        echo "<th scope='row'>Maximum downloads reached page</th>";
        echo "<td>";
        echo "<p class='description'>";
        echo "</p>";
        
        $sql = "SELECT
        			ID,
        			post_title
        		FROM {$wpdb->posts}
        		WHERE post_type = 'page'";
        
        $rows = $wpdb->get_results($sql);

        echo "<select name='mbs_maxdl_page'>";
        echo "<option value='0'>None</option>";
		foreach($rows as $row)
		{
			$selected = get_option('mbs_maxdl_page') == $row->ID ? "selected='selected'" : "";
			echo "<option value='{$row->ID}' $selected>{$row->post_title}</option>";	
		}
        echo "</select>";
                
        echo "</td>";
        echo "</tr>";
		?>
		<tr valign="top">
        <th scope="row">Expire links after...</th>
        <td>
		<input type='text' name='mbs_expire_link' value='<?php echo get_option('mbs_expire_link'); ?>' /> Days     
        </td>
        </tr>
         
        <tr valign="top">
        <th scope="row">Use Paypal Sandbox</th>
        <td>
        <?php
        	$checked = get_option('mbs_use_sandbox') ? "checked='checked'" : "";
        	echo "<input type='checkbox' name='mbs_use_sandbox' $checked />";
        ?>
        </td>
        </tr>
        <?php
        echo "<tr valign='top'>";
        echo "<th scope='row'>Thank you page / return page after the checkout process is completed</th>";
        echo "<td>";
        echo "<p class='description'>";
        echo "</p>";
        
        echo "<select name='mbs_return_page'>";
        echo "<option value='0'>No return page</option>";
		foreach($rows as $row)
		{
			$selected = get_option('mbs_return_page') == $row->ID ? "selected='selected'" : "";
			echo "<option value='{$row->ID}' $selected>{$row->post_title}</option>";	
		}
        echo "</select>";
                
        //echo "<input type='text' name='mbs_return_page' value='".get_option('mbs_return_page')."' />";
        echo "<p class='description'>";
        echo "Note: You can hide this page. It does not need to show up in any navigation.<br />";
        echo "<strong>Important: You need to activate &quot;Auto Return&quot; on the Profile Page &quot;Website Payment Preferences&quot; of your paypal account.</strong><br />";
        echo "</p>";
        echo "</td>";
        echo "</tr>";
        
        echo "<tr valign='top'>";
        echo "<th scope='row'>Subject of download link email</th>";
        echo "<td>";
        echo "<input type='text' name='mbs_emailsubject' value='".get_option('mbs_emailsubject')."' size='75' />";
        echo "</td>";
        echo "</tr>";
		
		echo "<tr valign='top'>";
        echo "<th scope='row'>Your name as shown in emails</th>";
        echo "<td>";
        echo "<input type='text' name='mbs_emailsender' value='".get_option('mbs_emailsender')."' size='75' />";
        echo "</td>";
        echo "</tr>";
        
        echo "<tr valign='top'>";
        echo '<th scope="row">Text of Download Link Mail<br />(variables beginning with "$" will be substituted)<br/>
		You can copy the following variables: <br/>$first_name<br/> $last_name<br/>$post_title<br/>$downloadlink<br/>$blogname<br/>
		</th>';
        echo "<td>";
        echo "<textarea name='mbs_emailtext' cols='75' rows='25'>";
        echo get_option('mbs_emailtext');
        echo "</textarea>";
        echo "</td>";
        echo "</tr>";
        
        echo "<tr valign='top'>";
        echo "<th scope='row'>Use short Download Link</th>";
        echo "<td>";
        
       	$checked = get_option('mbs_shortlink') ? "checked='checked'" : "";
       	echo "<input type='checkbox' name='mbs_shortlink' $checked onclick=\"var el = document.getElementById('htaccess'); if(this.checked) el.style.display = 'block'; else el.style.display = 'none'; \" />";
       	$hidden = get_option('mbs_shortlink') ? "" : "style='display:none;'";
       	
       	echo "<div id='htaccess' $hidden>";
       	echo "<p class='description'>";
		echo "Please insert at the <strong>beginning</strong> of your .htaccess:";
		echo "</p>";
		echo "<p>";
		echo "<textarea rows='10' cols='75'>";
		echo "<IfModule mod_rewrite.c>\n";
		echo "RewriteEngine On\n";
		echo "RewriteBase ".COOKIEPATH."\n";
		echo "RewriteRule ^efs/([\d\w]+)/?$ ".COOKIEPATH."wp-content/themes/myband/includes/mbfileshop/download.php?h=$1 [L]\n";
		echo "</IfModule>\n";
		echo "</textarea>";
		echo "</p>";
       	echo "</div>";
        echo "</td>";
        echo "</tr>";        
        
        ?>
    </table>
    <p class="submit">
    <input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
    </p>

</form>
</div>
<?php
}


function mbs_uninstall()
{
	global $wpdb;	
	$wpdb->query("DROP TABLE IF EXISTS  {$wpdb->prefix}mybandfileshop");
	
	delete_option( 'mbs_currency_code' );
	delete_option( 'sanitize_email');
	delete_option( 'mbs_use_sandbox' );
	delete_option( 'mbs_emailsubject' );
	delete_option( 'mbs_emailsender' );
	delete_option( 'mbs_emailtext' );
	delete_option( 'mbs_shortlink' );
}

function mbs_check_dir()
{
    if( !is_dir(MBS_DIR)
    	OR @file_put_contents(MBS_DIR."/testfile.tmp", "test") === false )
    {
    	return false;
    }
    else
    {
    	@unlink(MBS_DIR."/testfile.tmp");
    	
    	if(!file_exists(MBS_DIR."/.htaccess"))
    	{
    		file_put_contents(MBS_DIR."/.htaccess", "Order deny,allow\nDeny from all");
    		@chmod(MBS_DIR."/.htaccess", MBS_FILE_PERMISSIONS);
    	}
    	return true;    	
    }  	
}

function mbs_plugin_actions($links) {

    $settings_link = '<a href="admin.php?page=mbs-settings-page">Settings</a>';
    array_unshift( $links, $settings_link );

    return $links;
}

add_filter( 'plugin_action_links_' .plugin_basename(__FILE__), 'mbs_plugin_actions' );
?>