<?php class AlbumWidget extends WP_Widget
{
    function AlbumWidget(){
		$widget_ops = array('description' => 'Displays albums');
		$control_ops = array();
		parent::WP_Widget(false,$name='MyBand Album List Widget',$widget_ops,$control_ops);
    }

    function widget($args, $instance){
		extract($args);
		$title = apply_filters('widget_title', empty($instance['title']) ? 'List of posts' : $instance['title']);
		$postnumber = empty($instance['postnumber']) ? '' : $instance['postnumber'];
		
		$deltas = explode("class=\"", $before_widget);
		$params =  explode("\">",$deltas[1]);
?>
		<div class="service <?php echo str_replace("widget ", "", $params[0]) ?> albumlist" id="albumlist">
		<div id="blog-top"></div>
			<div id="blog-wrapper">
				<div id="blog-content">
					<?php if ( $title ) : ?><h4 class="widgettitle"><?php echo $title  ?></h4><?php endif;?>
					<div class="recentscroll">
						<ul>
							<?php
							query_posts('post_type=album&post_status=publish&posts_per_page='.$postnumber);
							if (have_posts()) :
							while (have_posts()) : the_post();
							global $post;
							if(get_post_meta($post->ID, 'album_excl_value', true) != 'yes') {
							?>
								<li class="clearfix">
									<span class='cover'>
										<a href="<?php the_permalink(); ?>">
										<?php echo get_the_post_thumbnail($post->ID, array(60,60)); ?>
										</a>
									</span>
									<span class="albumlink">
										<h3><a href="<?php the_permalink(); ?>"><?php truncate_title(30); ?></a></h3>
										<?php truncate_post(45); ?>
									</span>
								</li>
							<?php } endwhile; endif; wp_reset_query(); ?>
						</ul>
					</div>
				</div>
			</div>
			
			<div id="controllers2">
				<a href="#" id="left-arrow"><?php _e('Previous','MyBandTheme'); ?></a>
				<a href="#" id="right-arrow"><?php _e('Next','MyBandTheme'); ?></a>
			</div>
		</div>
		<?php }

    function update($new_instance, $old_instance){
		$instance = $old_instance;
		$instance['title'] = stripslashes($new_instance['title']);
		$instance['postnumber'] = stripslashes($new_instance['postnumber']);

		return $instance;
	}

    function form($instance){
		$instance = wp_parse_args( (array) $instance, array('title'=>'', 'postnumber'=>'') );

		$title = htmlspecialchars($instance['title']);
		$postnumber = htmlspecialchars($instance['postnumber']);

		echo '<p><label for="' . $this->get_field_id('title') . '">' . 'Title:' . '</label><input class="widefat" id="' . $this->get_field_id('title') . '" name="' . $this->get_field_name('title') . '" type="text" value="' . $title . '" /></p>';
		echo '<p><label for="' . $this->get_field_id('postnumber') . '">' . 'Number of post:' . '</label>
		<input class="widefat" id="' . $this->get_field_id('postnumber') . '" name="' . $this->get_field_name('postnumber') . '" type="text" value="' . $postnumber . '" /></p>';
	}

}

function AlbumWidgetInit() {
  register_widget('AlbumWidget');
}

add_action('widgets_init', 'AlbumWidgetInit');

?>