<?php class ListEventWidget extends WP_Widget
{
    function ListEventWidget(){
		$widget_ops = array('description' => 'Displays list posts of events');
		$control_ops = array();
		parent::WP_Widget(false,$name='MyBand Event List Widget',$widget_ops,$control_ops);
    }

    function widget($args, $instance){
		extract($args);
		$title = apply_filters('widget_title', empty($instance['title']) ? 'List of posts' : $instance['title']);
		$postnumber = empty($instance['postnumber']) ? '' : $instance['postnumber'];
		$dating = empty($instance['dating']) ? '' : $instance['dating'];
		$ordering = empty($instance['ordering']) ? '' : $instance['ordering'];
		
		$deltas = explode("class=\"", $before_widget);
		$params =  explode("\">",$deltas[1]);
?>
		<div class="service <?php echo str_replace("widget ", "", $params[0]) ?> eventlist" id="eventlist">
		<div id="blog-top"></div>
			<div id="blog-wrapper">
				<div id="blog-content">
					<?php if ( $title ) : ?><h4 class="widgettitle"><?php echo $title; ?></h4><?php endif;?>
					<div class="recentscroll">
						<ul>
							<?php 
			global $wpdb;
			
			switch($dating){
				case 'Upcoming Events':
					$sql_dating = '>= CURRENT_DATE()';
				break;
				
				case 'Recent Events':
					$sql_dating = '<= CURRENT_DATE()';
				break;
				
				case 'All Events':
					$sql_dating = '';
				break;
				
				default:
					$sql_dating = '>= CURRENT_DATE()';
				break;
			}
			
			switch($ordering){
				case 'Ascending':
					$sql_order = 'ASC';
				break;
				
				case 'Descending':
					$sql_order = 'DESC';
				break;
				
				default:
					$sql_order = 'ASC';
				break;
			}
			$strQuery="SELECT $wpdb->posts.* , STR_TO_DATE($wpdb->postmeta.meta_value, '%d-%b-%Y') as last_date
			FROM $wpdb->posts,$wpdb->postmeta
			WHERE $wpdb->posts.ID = $wpdb->postmeta.post_id  AND $wpdb->postmeta.meta_key = 'venue_date_value' 
			AND $wpdb->posts.post_type = 'event' AND ($wpdb->posts.post_status = 'publish' OR $wpdb->posts.post_status = 'future')  
			AND STR_TO_DATE($wpdb->postmeta.meta_value, '%d-%b-%Y') ".$sql_dating."
			ORDER BY last_date ".$sql_order."";
			
			$pageposts = $wpdb->get_results($strQuery, OBJECT);
			if ($pageposts)
			{
				$i=0;
				foreach ($pageposts as $post)
				{	
					if($i >= $postnumber && $postnumber != '') break;					
					setup_postdata($post);
					$exp_date = get_post_meta($post->ID,'venue_date_value',true);
					$expiration_date = strtotime($exp_date);
				?>
						<li class="clearfix">
							<a href="<?php echo get_permalink($post->ID); ?>" class="title"><span><?php echo get_the_title($post->ID); ?></span></a>
							<span class="postinfo">
							<?
							echo 'Date: '.date(get_option('myband_date_format'), $expiration_date);
							?></span>
						</li>
			<?php
				$i++;
				}
			}
			?>
						</ul>
					</div>
				</div>
			</div>
			
			<div id="controllers2">
				<a href="#" id="left-arrow"><?php _e('Previous','MyBandTheme'); ?></a>
				<a href="#" id="right-arrow"><?php _e('Next','MyBandTheme'); ?></a>
			</div>
		</div>
		<?php }

    function update($new_instance, $old_instance){
		$instance = $old_instance;
		$instance['title'] = stripslashes($new_instance['title']);
		$instance['postnumber'] = stripslashes($new_instance['postnumber']);
		$instance['ordering'] = stripslashes($new_instance['ordering']);
		$instance['dating'] = stripslashes($new_instance['dating']);

		return $instance;
	}

    function form($instance){
		$instance = wp_parse_args( (array) $instance, array('title'=>'', 'postnumber'=>'', 'ordering'=>'', 'dating'=>'') );

		$title = htmlspecialchars($instance['title']);
		$postnumber = htmlspecialchars($instance['postnumber']);

		echo '<p><label for="' . $this->get_field_id('title') . '">' . 'Title:' . '</label><input class="widefat" id="' . $this->get_field_id('title') . '" name="' . $this->get_field_name('title') . '" type="text" value="' . $title . '" /></p>';
		echo '<p><label for="' . $this->get_field_id('postnumber') . '">' . 'Number of events:' . '</label>
		<input class="widefat" id="' . $this->get_field_id('postnumber') . '" name="' . $this->get_field_name('postnumber') . '" type="text" value="' . $postnumber . '" /></p>';
		
		?>

        <p>
            <label for="<?php echo $this->get_field_id( 'dating' ); ?>"><?php _e('Event Dates:', ''); ?></label> 
            <select id="<?php echo $this->get_field_id( 'dating' ); ?>" name="<?php echo $this->get_field_name( 'dating' ); ?>" style="width:100%;">
                <option <?php if ( 'Upcoming Events' == $instance['dating'] ) echo 'selected="selected"'; ?>>Upcoming Events</option>
                <option <?php if ( 'Recent Events' == $instance['dating'] ) echo 'selected="selected"'; ?>>Recent Events</option>
				<option <?php if ( 'All Events' == $instance['dating'] ) echo 'selected="selected"'; ?>>All Events</option>
            </select>
        </p>

        <p>
            <label for="<?php echo $this->get_field_id( 'ordering' ); ?>"><?php _e('Ordering:', ''); ?></label> 
            <select id="<?php echo $this->get_field_id( 'ordering' ); ?>" name="<?php echo $this->get_field_name( 'ordering' ); ?>" style="width:100%;">
				<option <?php if ( 'Ascending' == $instance['ordering'] ) echo 'selected="selected"'; ?>>Ascending</option>
				<option <?php if ( 'Descending' == $instance['ordering'] ) echo 'selected="selected"'; ?>>Descending</option>
            </select>
        </p>
	<?php		
	}
}

function ListEventWidgetInit() {
  register_widget('ListEventWidget');
}

add_action('widgets_init', 'ListEventWidgetInit');

?>