<?php class ListPostWidget extends WP_Widget
{
    function ListPostWidget(){
		$widget_ops = array('description' => 'Displays list posts of special category');
		$control_ops = array();
		parent::WP_Widget(false,$name='MyBand Blog Post Widget',$widget_ops,$control_ops);
    }

    function widget($args, $instance){
		extract($args);
		$title = apply_filters('widget_title', empty($instance['title']) ? 'List of posts' : $instance['title']);
		$postnumber = empty($instance['postnumber']) ? '' : $instance['postnumber'];
		$categoryId = empty($instance['categoryId']) ? '' : $instance['categoryId'];

		$deltas = explode("class=\"", $before_widget);
		$params =  explode("\">",$deltas[1]);
?>
		<div class="service <?php echo str_replace("widget ", "", $params[0]) ?> bloglist" id="blog">
		<div id="blog-top"></div>
			<div id="blog-wrapper">
				<div id="blog-content">
					<?php if ( $title ) : ?><h4 class="widgettitle"><?php echo $title  ?></h4><?php endif;?>
					<div class="recentscroll">
						<ul>
							<?php query_posts("showposts=".$postnumber."&cat=".$categoryId."&posts_per_page=".$postnumber );
							if (have_posts()) : while (have_posts()) : the_post(); ?>
								<li class="clearfix">
									<a href="<?php the_permalink(); ?>" class="title"><span><?php truncate_title(30); ?></span></a>
									<span class="postinfo"><?php _e('Posted','myband'); ?> <?php _e('by','myband'); ?> <?php the_author_posts_link(); ?> <?php _e('on','myband'); ?> <?php the_time(get_option('myband_date_format')) ?></span>
								</li>
							<?php endwhile; endif; wp_reset_query(); ?>
						</ul>
					</div>
				</div>
			</div>
			
			<div id="controllers2">
				<a href="#" id="left-arrow"><?php _e('Previous','MyBandTheme'); ?></a>
				<a href="#" id="right-arrow"><?php _e('Next','MyBandTheme'); ?></a>
			</div>
		</div>
		<?php }

    function update($new_instance, $old_instance){
		$instance = $old_instance;
		$instance['title'] = stripslashes($new_instance['title']);
		$instance['postnumber'] = stripslashes($new_instance['postnumber']);
		$instance['categoryId'] = stripslashes($new_instance['categoryId']);

		return $instance;
	}

    function form($instance){
		$instance = wp_parse_args( (array) $instance, array('title'=>'', 'postnumber'=>'', 'categoryId'=>'') );

		$title = htmlspecialchars($instance['title']);
		$postnumber = htmlspecialchars($instance['postnumber']);
		$categoryId = htmlspecialchars($instance['categoryId']);

		echo '<p><label for="' . $this->get_field_id('title') . '">' . 'Title:' . '</label><input class="widefat" id="' . $this->get_field_id('title') . '" name="' . $this->get_field_name('title') . '" type="text" value="' . $title . '" /></p>';
		echo '<p><label for="' . $this->get_field_id('postnumber') . '">' . 'Number of post:' . '</label>
		<input class="widefat" id="' . $this->get_field_id('postnumber') . '" name="' . $this->get_field_name('postnumber') . '" type="text" value="' . $postnumber . '" /></p>';
		echo '<p><label for="' . $this->get_field_id('categoryId') . '">' . 'CategoryId:' . '</label><input class="widefat" id="' . $this->get_field_id('categoryId') . '" name="' . $this->get_field_name('categoryId') . '" type="text" value="' . $categoryId . '" /></p>';
	}

}

function ListPostWidgetInit() {
  register_widget('ListPostWidget');
}

add_action('widgets_init', 'ListPostWidgetInit');

?>