<?php class PlayerWidget extends WP_Widget
{
    function PlayerWidget(){
		$widget_ops = array('description' => 'Play an album with this music player');
		$control_ops = array();
		parent::WP_Widget(false,$name='MyBand Music Player Widget',$widget_ops,$control_ops);
    }

    function widget($args, $instance){
		extract($args);
		$albumID = empty($instance['albumID']) ? '' : $instance['albumID'];
		$title = apply_filters('widget_title', empty($instance['title']) ? get_the_title($albumID) : $instance['title']);
		$deltas = explode("class=\"", $before_widget);
		$params =  explode("\">",$deltas[1]);
		$deltaNum = preg_replace('/[^0-9]/i', '', $params[0])+1;
		$dropDownState = $instance['dropDownState'];
		
		if(isset($albumID) && $albumID != ''):
?>
<div class="service <?php echo str_replace("widget ", "", $params[0]) ?>" id="musicplayer">
<div id="blog-top"></div>
	<div id="blog-wrapper">
		<div id="blog-content">
			<?php if ( $title ) : ?><h4 class="widgettitle"><?php echo $title; ?></h4><?php endif;?>
				<?php
				$song_id=get_post_meta($albumID,'add_song_value',true);
				if($song_id!="") { ?>
				<div id="jquery_jplayer_<?php echo $deltaNum; ?>" class="jp-jplayer"></div>
				<div class="jp-audio">
					<div id="block-player">
						<div class='albumcover'>
							<a href="<?php
							query_posts('post_type=album&p='.$albumID);
							if (have_posts()) {
								while (have_posts()){
									the_post();
									global $post;
									if($post->ID == $albumID){
										the_permalink();										
									}
								}
							} 
							?>">
							<?
							echo get_the_post_thumbnail($albumID, array(96,96));
							?>
							</a>
						</div>
						<div id="block-player-title<?php echo $deltaNum; ?>" class="bpt"></div>
						<div id="block-playcount<?php echo $deltaNum; ?>"></div>
						<div class="jp-interface" id="jp_interface_<?php echo $deltaNum; ?>">
						<div class="oval-wrap ctrl">
							<div class='oval-content'>
								<ul class="jp-controls">
									<li><a href="#" class="jp-previous" tabindex="1">previous</a></li>
									<li><a href="#" class="jp-play" tabindex="1">play</a></li>
									<li><a href="#" class="jp-pause" tabindex="1">pause</a></li>
									<li><a href="#" class="jp-next" tabindex="1">next</a></li>
									<li><span class="jp-playlistdd plst<?php echo $deltaNum; ?>">playlist</span></li>
								</ul>
							</div>
						</div>
						<div class='block-jp-seek'>
							<div class="jp-current-time"></div>
							<div class="jp-progress">
								<div class="jp-seek-bar">
									<div class="jp-play-bar"></div>
								</div>
							</div>
							<div class="jp-duration"></div>
						</div>
					</div>
					
					<div id="jp_playlist_<?php echo $deltaNum; ?>" class="jp-playlist collist<?php echo $deltaNum; ?>"></div>
				</div>
					<script type="text/javascript">	
					//<![CDATA[
				jQuery(document).ready(function(){
					$listFold = jQuery('.plst<?php echo $deltaNum; ?>');
					$listFold.live('click', function() {
						if (jQuery('.collist<?php echo $deltaNum; ?>').hasClass('open') ) 
							jQuery('.collist<?php echo $deltaNum; ?>').removeClass('open');
						else 
							jQuery('.collist<?php echo $deltaNum; ?>').addClass('open');

						jQuery('.collist<?php echo $deltaNum; ?>').animate({ opacity: 'toggle', height: 'toggle' }, 300);
					});
					<?php if($dropDownState): ?>
						jQuery('.collist<?php echo $deltaNum; ?>').addClass('open');
						jQuery('.collist<?php echo $deltaNum; ?>').animate({ opacity: 'toggle', height: 'toggle' }, 0);
					<?php endif; ?>
					
					var Playlist = function(instance, playlist, options) {
						var self = this;

						this.instance = instance;
						this.playlist = playlist;
						this.options = options;

						this.current = 0;

						this.cssId = {
							jPlayer: "jquery_jplayer_",
							interface: "jp_interface_",
							playlist: "jp_playlist_"
						};
						this.cssSelector = {};

						jQuery.each(this.cssId, function(entity, id) {
							self.cssSelector[entity] = "#" + id + self.instance;
						});

						if(!this.options.cssSelectorAncestor) {
							this.options.cssSelectorAncestor = this.cssSelector.interface;
						}

						jQuery(this.cssSelector.jPlayer).jPlayer(this.options);
						
						jQuery(this.cssSelector.interface + " .jp-previous").click(function() {
							self.playlistPrev();
							jQuery(this).blur();
							return false;
						});

						jQuery(this.cssSelector.interface + " .jp-next").click(function() {
							self.playlistNext();
							jQuery(this).blur();
							return false;
						});
					};

					Playlist.prototype = {
						displayPlaylist: function() {
							var self = this;
							jQuery(this.cssSelector.playlist).empty();
							for (i=0; i < this.playlist.length; i++) {
								var listItem = "<div class='oval-wrap nm'><div class='oval-content'><a href='#' id='" + this.cssId.playlist + this.instance + "_item_" + i +"' tabindex='1'>"+ this.playlist[i].name +"</a></div></div>";

								jQuery(this.cssSelector.playlist).append(listItem);
								jQuery(this.cssSelector.playlist + "_item_" + i).data("index", i).click(function() {
									var index = jQuery(this).data("index");
									if(self.current !== index) {
										self.playlistChange(index);
									} else {
										jQuery(self.cssSelector.jPlayer).jPlayer("play");
									}
									jQuery(this).blur();
									return false;
								});
							}
						},
						playlistInit: function(autoplay) {
							if(autoplay) {
								this.playlistChange(this.current);
							} else {
								this.playlistConfig(this.current);
							}
						},
						playlistConfig: function(index) {
							jQuery(this.cssSelector.playlist + "_item_" + this.current).removeClass("jp-playlist-current").parent().removeClass("jp-playlist-current");
							jQuery(this.cssSelector.playlist + "_item_" + index).addClass("jp-playlist-current").parent().addClass("jp-playlist-current");
							this.current = index;
							jQuery(this.cssSelector.jPlayer).jPlayer("setMedia", this.playlist[this.current]);
							jQuery('#block-player-title<?php echo $deltaNum; ?>').html(this.playlist[index].shorttitle);
							if(this.playlist[index].count == ''){
								jQuery('#block-player-count<?php echo $deltaNum; ?>').hide();
							}
							else{
								jQuery('#block-player-count<?php echo $deltaNum; ?>').show();
								if(this.playlist[index].formattedplays == undefined){
									jQuery('#block-playcount<?php echo $deltaNum; ?>').html('0 <?php echo translate('plays','myband'); ?>');
								}else{
									jQuery('#block-playcount<?php echo $deltaNum; ?>').html(this.playlist[index].formattedplays + ' <?php echo translate('plays','myband'); ?>');				
								}

							}
						},
						playlistChange: function(index) {
							this.playlistConfig(index);
							jQuery(this.cssSelector.jPlayer).jPlayer("play");
						},
						playlistNext: function() {
							var index = (this.current + 1 < this.playlist.length) ? this.current + 1 : 0;
							this.playlistChange(index);
						},
						playlistPrev: function() {
							var index = (this.current - 1 >= 0) ? this.current - 1 : this.playlist.length - 1;
							this.playlistChange(index);
						}
					};

					var audioPlaylist<?php echo $deltaNum; ?> = new Playlist("<?php echo $deltaNum; ?>", [
							<?php
							$song_id=explode(",", $song_id);
							$nums=1;
							foreach ($song_id as $value) {
								if($value !="") {
									$previewmp3 = get_post_meta($post->ID,'song_preview'.$value,true);
									if($previewmp3 !="") {
										$mp3 = $previewmp3;
									}
									$plays = get_post_meta($post->ID,'song_count'.$value,true);
									$formattedplays = number_format((double)$plays);
									$trackTitle = addslashes(get_post_meta($albumID,'song_title'.$value,true));
									$shorttitle = addslashes(get_post_meta($albumID,'song_title'.$value,true));
									if (strlen($trackTitle) > 25 ) $trackTitle = substr($trackTitle,0,25)."...";
									if (strlen($shorttitle) > 25 ) $shorttitle = substr($shorttitle,0,25)."...";
							?>
						{
							name:"<?php echo $nums.'. '.$trackTitle; ?>",
							mp3:"<?php echo $mp3; ?>",
							plays:"<?php echo $plays; ?>",
							formattedplays:"<?php echo $formattedplays; ?>",
							songID:"<?php echo $value; ?>",
							shorttitle:"<?php echo $nums.'. '.$shorttitle; ?>"
						},
						<?php } $nums++; } ?>
					], {
						ready: function() {
							audioPlaylist<?php echo $deltaNum; ?>.playlistInit(false);
							audioPlaylist<?php echo $deltaNum; ?>.displayPlaylist();
						},
						ended: function() {
							audioPlaylist<?php echo $deltaNum; ?>.playlistNext();
						},
						play: function() {
							jQuery(this).jPlayer("pauseOthers");
							// Update Counter
							jQuery.post("<?php echo get_bloginfo('template_url'); ?>/includes/mbfileshop/playcounter.php", {"postID": <?php echo $albumID; ?>, "songID": audioPlaylist<?php echo $deltaNum; ?>.playlist[audioPlaylist<?php echo $deltaNum; ?>.current].songID, "plays": audioPlaylist<?php echo $deltaNum; ?>.playlist[audioPlaylist<?php echo $deltaNum; ?>.current].plays});
						},
						swfPath: "<?php echo get_bloginfo('template_directory').'/js'; ?>",
						supplied: "mp3"
					});
				});
					//]]>
					</script>
						</div>
						<?php }
					?>
		</div>
	</div>

</div>
		<?php endif; }
    function update($new_instance, $old_instance){
		$instance = $old_instance;
		$instance['title'] = stripslashes($new_instance['title']);
		$instance['albumID'] = stripslashes($new_instance['albumID']);
		$instance['dropDownState'] = $new_instance['dropDownState'];

		return $instance;
	}
    function form($instance){
		$instance = wp_parse_args( (array) $instance, array('title'=>'', 'albumID'=>'', 'dropDownState'=>'') );

		$title = htmlspecialchars($instance['title']);
		$albumID = htmlspecialchars($instance['albumID']);		
		$dropDownState = isset( $instance['dropDownState'] ) ? (bool) $instance['dropDownState'] : false;
		
		$args = array(
			'post_type' => 'album',
			'numberposts' => -1
		);
		$albums = get_posts($args);
		

		echo '<p><label for="' . $this->get_field_id('title') . '">' . 'Title:' . '</label><input class="widefat" id="' . $this->get_field_id('title') . '" name="' . $this->get_field_name('title') . '" type="text" value="' . $title . '" /></p>';
		
		echo '<p><label for="' . $this->get_field_id('albumID') . '">' . 'Album:' . '</label>';
		echo '<select id="'.$this->get_field_id('albumID').'" name="'.$this->get_field_name('albumID').'" style="width:220px"><option value="">'.__('Select Album', '').'</option>';
	    foreach( $albums as $album ){
			if (stripslashes($album->ID == $albumID)) {
				$tmp = ' selected="selected"';
			} else {
				$tmp = '';
			}
	        echo '<option value="' . $album->ID . '" '.$tmp.'>' . esc_html( $album->post_title ) . '</option>';
	    }
	    echo '</select></p>';
	
		echo '<p><input type="checkbox" class="checkbox" id="' . $this->get_field_id('dropDownState') . '" name="' . $this->get_field_name('dropDownState') . '" '.checked( $dropDownState, true, false ).' /><label for="' . $this->get_field_id('dropDownState') . '">' . ' Open playlist by default' . '</label></p>';
		
	}
}

function PlayerWidgetInit() {
  register_widget('PlayerWidget');
}

add_action('widgets_init', 'PlayerWidgetInit');
?>