/* <![CDATA[ */
	// mb_switcher plugin v2
	(function($)
	{
		$.fn.mb_shortcodes_switcher = function(options)
		{
		
			$('.rounded-corner').corner("10px");
			$('.mb-testimonial-box').corner("10px");
			
			var defaults =
			{
			   slides: '>div',
			   activeClass: 'active',
			   linksNav: '',
			   findParent: true, //use parent elements to define active states
			   lengthElement: 'li', //parent element, used only if findParent is set to true
			   useArrows: false,
			   arrowLeft: 'a#prev-arrow',
			   arrowRight: 'a#next-arrow',
			   auto: false,
			   autoSpeed: 5000,
			   slidePadding: '',
			   pauseOnHover: true,
			   fx: 'fade',
			   sliderType: ''
			};

			var options = $.extend(defaults, options);

			return this.each(function()
			{
								
				var slidesContainer = jQuery(this).parent().css('position','relative'),
					$slides = jQuery(this).css({'overflow':'hidden','position':'relative'}),
					$slide = $slides.find(options.slides).css({'opacity':'1','position':'absolute','top':'0px','left':'0px','display':'none'}),
					slidesNum = $slide.length,
					zIndex = slidesNum,
					currentPosition = 1,
					slideHeight = 0,
					$activeSlide,
					$nextSlide;
				
				if (options.fx === 'slide') {
					$slide.css({'opacity':'0','position':'absolute','top':'0px','left':'0px','display':'block'});
				} else {
					$slide.filter(':first').css({'display':'block'});
				}
				
				if (options.slidePadding != '') $slide.css('padding',options.slidePadding);
				
				$slide.each(function(){
					jQuery(this).css('z-index',zIndex).addClass('clearfix');
					if (options.fx === 'slide') zIndex--;
					
					slideH = jQuery(this).innerHeight();
					if (slideH > slideHeight) slideHeight = slideH;
				});
				
				//check left tabs container height
				if ( slidesContainer.hasClass('tabs-left') ) {
					var leftTabsHeight = slidesContainer.find('ul.mb-tabs-control').innerHeight();
					if ( leftTabsHeight > slideHeight ) slideHeight = leftTabsHeight;
				}
				
				slidesContainer.find('.mb-learn-more').not('.mb-open').find('.learn-more-content').css({'display':'none','visibility': 'visible'});
				
				if ( jQuery.browser.msie ) {
					if ( slidesContainer.hasClass('mb-simple-slider') ) $slides.css('height', slideHeight+10);
					else $slides.css('height', slideHeight+40);
				} else {
					$slides.css('height', slideHeight);
				}
				$slides.css('width', $slides.width());
								
				var slideWidth = $slide.width(),
					slideOuterWidth = $slide.outerWidth();
				
				if ( jQuery.browser.msie && !slidesContainer.hasClass('mb-simple-slider') ) {
					$slide.css('width',slideWidth-22);
				} else {
					$slide.css('width',slideWidth);
				}
				
				$slide.filter(':first').css('opacity','1');
				
				if (options.sliderType != '') {
					if (options.sliderType === 'images') {
						controllersHtml = '<div class="controllers-wrapper"><div class="controllers"><a href="#" class="left-arrow">Previous</a>';
						for ($i=1; $i<=slidesNum; $i++) {
							controllersHtml += '<a class="switch" href="#">'+$i+'</a>';
						}
						controllersHtml += '<a href="#" class="right-arrow">Next</a></div><div class="controllers-right"></div></div>';		
						$controllersWrap = jQuery(controllersHtml).prependTo($slides.parent());
						jQuery('.controllers-wrapper .controllers').css('width', 65 + 18*slidesNum);
					}
					
					var mbimage_width = $slide.width();
		
					slidesContainer.css({'width':mbimage_width});
					$slides.css({'width':mbimage_width});
										
					if (options.sliderType === 'images') {
						slidesContainer.css({'height':$slide.height()});
						$slides.css({'height':$slide.height()});
						
						var controllers_width = $controllersWrap.width(),
						leftPosition = Math.round((mbimage_width - controllers_width) / 2);
					
						$controllersWrap.css({left: leftPosition});
					}	
				}
				
				
				if (options.linksNav != '') {
					var linkSwitcher = jQuery(options.linksNav);
					
					var linkSwitcherTab = '';
					if (options.findParent) linkSwitcherTab = linkSwitcher.parent();
					else linkSwitcherTab = linkSwitcher;
					
					if (!linkSwitcherTab.filter('.active').length) linkSwitcherTab.filter(':first').addClass('active');
									
					linkSwitcher.click(function(){
						
						var targetElement;

						if (options.findParent) targetElement = jQuery(this).parent();
						else targetElement = jQuery(this);
						
						var orderNum = targetElement.prevAll(options.lengthElement).length+1;
						
						if (orderNum > currentPosition) gotoSlide(orderNum, 1);
						else gotoSlide(orderNum, -1); 
						
						return false;
					});
				}
				
				
				if (options.useArrows) {
					var $right_arrow = jQuery(options.arrowRight),
						$left_arrow = jQuery(options.arrowLeft);
										
					$right_arrow.click(function(){				
						if (currentPosition === slidesNum) 
							gotoSlide(1,1);
						else 
							gotoSlide(currentPosition+1),1;
						
						if (options.linksNav != '') changeTab();
												
						return false;
					});
					
					$left_arrow.click(function(){
						if (currentPosition === 1)
							gotoSlide(slidesNum,-1);
						else 
							gotoSlide(currentPosition-1,-1);
						
						if (options.linksNav != '') changeTab();
						
						return false;
					});
					
				}
				
								
				function changeTab(){
					if (linkSwitcherTab != '') { 
						linkSwitcherTab.siblings().removeClass('active');
						linkSwitcherTab.filter(':eq('+(currentPosition-1)+')').addClass('active');
					}
				}
				
				function gotoSlide(slideNumber,dir){
					if ($slide.filter(':animated').length) return;
				
					$slide.css('opacity','0');
																		
					$activeSlide = $slide.filter(':eq('+(currentPosition-1)+')').css('opacity','1');
									
					if (currentPosition === slideNumber) return;
									
					$nextSlide = $slide.filter(':eq('+(slideNumber-1)+')').css('opacity','1');
									
					if ((currentPosition > slideNumber || currentPosition === 1) && (dir === -1)) {
						if (options.fx === 'slide') slideBack(500);
						if (options.fx === 'fade') slideFade(500);
					} else {
						if (options.fx === 'slide') slideForward(500);
						if (options.fx === 'fade') slideFade(500);
					}
					
					currentPosition = $nextSlide.prevAll().length + 1;
					
					if (options.linksNav != '') changeTab();
					
					if (typeof interval_shortcodes != 'undefined' && options.auto) {
						clearInterval(interval_shortcodes);
						auto_rotate();
					}
										
					return false;
				}
				
				
				if (options.auto) {
					auto_rotate();
					var pauseSlider = false;
				}
				
				if (options.pauseOnHover) { 				
					slidesContainer.hover(function(){
						pauseSlider = true;
					},function(){
						pauseSlider = false;
					});
				}
				
				function auto_rotate(){
					
					interval_shortcodes = setInterval(function(){
						if (!pauseSlider) { 
							if (currentPosition === slidesNum) 
								gotoSlide(1,1);
							else 
								gotoSlide(currentPosition+1),1;
							
							if (options.linksNav != '') changeTab();
						}
					},options.autoSpeed);
					
				}
				
				function slideForward(speed){
					$nextSlide.css('left',slideOuterWidth+'px');
					$activeSlide.animate({left: '-'+slideOuterWidth},speed);
					$nextSlide.animate({left: 0},speed);
				}
				
				function slideBack(speed){
					$nextSlide.css('left','-'+slideOuterWidth+'px');
					$activeSlide.animate({left: slideOuterWidth},speed);
					$nextSlide.animate({left: 0},speed);
				}
				
				function slideFade(speed){					
					$activeSlide.css({zIndex: slidesNum}).fadeOut(700);
					$nextSlide.css({zIndex: (slidesNum+1)}).fadeIn(700);
				}
				
			});
		} 
	})(jQuery);
	// end mb_switcher plugin v2
		
	/////// Shortcodes Javascript ///////
	(function($){
		$mb_tooltip = $('.mb-tooltip');
		$mb_tooltip.live('mouseover mouseout', function(event){
			if (event.type == 'mouseover') {
				$(this).find('.mb-tooltip-box').animate({ opacity: 'show', bottom: '25px' }, 300);
			} else {
				$(this).find('.mb-tooltip-box').animate({ opacity: 'hide', bottom: '35px' }, 300);
			}
		});
		// learn more
		$mb_learn_more = $('.mb-learn-more .heading-more');
		$mb_learn_more.live('click', function() {
			if ( $(this).hasClass('open') ) 
				$(this).removeClass('open');
			else 
				$(this).addClass('open');
			
			$(this).parent('.mb-learn-more').find('.learn-more-content').animate({ opacity: 'toggle', height: 'toggle' }, 300);
		});
	})(jQuery);
/* ]]> */

/*!
 * jQuery corner plugin: simple corner rounding
 * Examples and documentation at: http://jquery.malsup.com/corner/
 * version 2.11 (15-JUN-2010)
 * Requires jQuery v1.3.2 or later
 * Dual licensed under the MIT and GPL licenses:
 * http://www.opensource.org/licenses/mit-license.php
 * http://www.gnu.org/licenses/gpl.html
 * Authors: Dave Methvin and Mike Alsup
 */

/**
 *  corner() takes a single string argument:  $('#myDiv').corner("effect corners width")
 *
 *  effect:  name of the effect to apply, such as round, bevel, notch, bite, etc (default is round). 
 *  corners: one or more of: top, bottom, tr, tl, br, or bl.  (default is all corners)
 *  width:   width of the effect; in the case of rounded corners this is the radius. 
 *           specify this value using the px suffix such as 10px (yes, it must be pixels).
 */
;(function($) { 

var style = document.createElement('div').style,
    moz = style['MozBorderRadius'] !== undefined,
    webkit = style['WebkitBorderRadius'] !== undefined,
    radius = style['borderRadius'] !== undefined || style['BorderRadius'] !== undefined,
    mode = document.documentMode || 0,
    noBottomFold = $.browser.msie && (($.browser.version < 8 && !mode) || mode < 8),

    expr = $.browser.msie && (function() {
        var div = document.createElement('div');
        try { div.style.setExpression('width','0+0'); div.style.removeExpression('width'); }
        catch(e) { return false; }
        return true;
    })();

$.support = $.support || {};
$.support.borderRadius = moz || webkit || radius; // so you can do:  if (!$.support.borderRadius) $('#myDiv').corner();

function sz(el, p) { 
    return parseInt($.css(el,p))||0; 
};
function hex2(s) {
    var s = parseInt(s).toString(16);
    return ( s.length < 2 ) ? '0'+s : s;
};
function gpc(node) {
    while(node) {
        var v = $.css(node,'backgroundColor'), rgb;
        if (v && v != 'transparent' && v != 'rgba(0, 0, 0, 0)') {
            if (v.indexOf('rgb') >= 0) { 
                rgb = v.match(/\d+/g); 
                return '#'+ hex2(rgb[0]) + hex2(rgb[1]) + hex2(rgb[2]);
            }
            return v;
        }
        if (node.nodeName.toLowerCase() == 'html')
            break;
        node = node.parentNode; // keep walking if transparent
    }
    return '#ffffff';
};

function getWidth(fx, i, width) {
    switch(fx) {
    case 'round':  return Math.round(width*(1-Math.cos(Math.asin(i/width))));
    case 'cool':   return Math.round(width*(1+Math.cos(Math.asin(i/width))));
    case 'sharp':  return Math.round(width*(1-Math.cos(Math.acos(i/width))));
    case 'bite':   return Math.round(width*(Math.cos(Math.asin((width-i-1)/width))));
    case 'slide':  return Math.round(width*(Math.atan2(i,width/i)));
    case 'jut':    return Math.round(width*(Math.atan2(width,(width-i-1))));
    case 'curl':   return Math.round(width*(Math.atan(i)));
    case 'tear':   return Math.round(width*(Math.cos(i)));
    case 'wicked': return Math.round(width*(Math.tan(i)));
    case 'long':   return Math.round(width*(Math.sqrt(i)));
    case 'sculpt': return Math.round(width*(Math.log((width-i-1),width)));
    case 'dogfold':
    case 'dog':    return (i&1) ? (i+1) : width;
    case 'dog2':   return (i&2) ? (i+1) : width;
    case 'dog3':   return (i&3) ? (i+1) : width;
    case 'fray':   return (i%2)*width;
    case 'notch':  return width; 
    case 'bevelfold':
    case 'bevel':  return i+1;
    }
};

$.fn.corner = function(options) {
    // in 1.3+ we can fix mistakes with the ready state
    if (this.length == 0) {
        if (!$.isReady && this.selector) {
            var s = this.selector, c = this.context;
            $(function() {
                $(s,c).corner(options);
            });
        }
        return this;
    }

    return this.each(function(index){
        var $this = $(this),
            // meta values override options
            o = [$this.attr($.fn.corner.defaults.metaAttr) || '', options || ''].join(' ').toLowerCase(),
            keep = /keep/.test(o),                       // keep borders?
            cc = ((o.match(/cc:(#[0-9a-f]+)/)||[])[1]),  // corner color
            sc = ((o.match(/sc:(#[0-9a-f]+)/)||[])[1]),  // strip color
            width = parseInt((o.match(/(\d+)px/)||[])[1]) || 10, // corner width
            re = /round|bevelfold|bevel|notch|bite|cool|sharp|slide|jut|curl|tear|fray|wicked|sculpt|long|dog3|dog2|dogfold|dog/,
            fx = ((o.match(re)||['round'])[0]),
            fold = /dogfold|bevelfold/.test(o),
            edges = { T:0, B:1 },
            opts = {
                TL:  /top|tl|left/.test(o),       TR:  /top|tr|right/.test(o),
                BL:  /bottom|bl|left/.test(o),    BR:  /bottom|br|right/.test(o)
            },
            // vars used in func later
            strip, pad, cssHeight, j, bot, d, ds, bw, i, w, e, c, common, $horz;
        
        if ( !opts.TL && !opts.TR && !opts.BL && !opts.BR )
            opts = { TL:1, TR:1, BL:1, BR:1 };
            
        // support native rounding
        if ($.fn.corner.defaults.useNative && fx == 'round' && (radius || moz || webkit) && !cc && !sc) {
            if (opts.TL)
                $this.css(radius ? 'border-top-left-radius' : moz ? '-moz-border-radius-topleft' : '-webkit-border-top-left-radius', width + 'px');
            if (opts.TR)
                $this.css(radius ? 'border-top-right-radius' : moz ? '-moz-border-radius-topright' : '-webkit-border-top-right-radius', width + 'px');
            if (opts.BL)
                $this.css(radius ? 'border-bottom-left-radius' : moz ? '-moz-border-radius-bottomleft' : '-webkit-border-bottom-left-radius', width + 'px');
            if (opts.BR)
                $this.css(radius ? 'border-bottom-right-radius' : moz ? '-moz-border-radius-bottomright' : '-webkit-border-bottom-right-radius', width + 'px');
            return;
        }
            
        strip = document.createElement('div');
        $(strip).css({
            overflow: 'hidden',
            height: '1px',
            minHeight: '1px',
            fontSize: '1px',
            backgroundColor: sc || 'transparent',
            borderStyle: 'solid'
        });
    
        pad = {
            T: parseInt($.css(this,'paddingTop'))||0,     R: parseInt($.css(this,'paddingRight'))||0,
            B: parseInt($.css(this,'paddingBottom'))||0,  L: parseInt($.css(this,'paddingLeft'))||0
        };

        if (typeof this.style.zoom != undefined) this.style.zoom = 1; // force 'hasLayout' in IE
        if (!keep) this.style.border = 'none';
        strip.style.borderColor = cc || gpc(this.parentNode);
        cssHeight = $(this).outerHeight();

        for (j in edges) {
            bot = edges[j];
            // only add stips if needed
            if ((bot && (opts.BL || opts.BR)) || (!bot && (opts.TL || opts.TR))) {
                strip.style.borderStyle = 'none '+(opts[j+'R']?'solid':'none')+' none '+(opts[j+'L']?'solid':'none');
                d = document.createElement('div');
                $(d).addClass('jquery-corner');
                ds = d.style;

                bot ? this.appendChild(d) : this.insertBefore(d, this.firstChild);

                if (bot && cssHeight != 'auto') {
                    if ($.css(this,'position') == 'static')
                        this.style.position = 'relative';
                    ds.position = 'absolute';
                    ds.bottom = ds.left = ds.padding = ds.margin = '0';
                    if (expr)
                        ds.setExpression('width', 'this.parentNode.offsetWidth');
                    else
                        ds.width = '100%';
                }
                else if (!bot && $.browser.msie) {
                    if ($.css(this,'position') == 'static')
                        this.style.position = 'relative';
                    ds.position = 'absolute';
                    ds.top = ds.left = ds.right = ds.padding = ds.margin = '0';
                    
                    // fix ie6 problem when blocked element has a border width
                    if (expr) {
                        bw = sz(this,'borderLeftWidth') + sz(this,'borderRightWidth');
                        ds.setExpression('width', 'this.parentNode.offsetWidth - '+bw+'+ "px"');
                    }
                    else
                        ds.width = '100%';
                }
                else {
                    ds.position = 'relative';
                    ds.margin = !bot ? '-'+pad.T+'px -'+pad.R+'px '+(pad.T-width)+'px -'+pad.L+'px' : 
                                        (pad.B-width)+'px -'+pad.R+'px -'+pad.B+'px -'+pad.L+'px';                
                }

                for (i=0; i < width; i++) {
                    w = Math.max(0,getWidth(fx,i, width));
                    e = strip.cloneNode(false);
                    e.style.borderWidth = '0 '+(opts[j+'R']?w:0)+'px 0 '+(opts[j+'L']?w:0)+'px';
                    bot ? d.appendChild(e) : d.insertBefore(e, d.firstChild);
                }
                
                if (fold && $.support.boxModel) {
                    if (bot && noBottomFold) continue;
                    for (c in opts) {
                        if (!opts[c]) continue;
                        if (bot && (c == 'TL' || c == 'TR')) continue;
                        if (!bot && (c == 'BL' || c == 'BR')) continue;
                        
                        common = { position: 'absolute', border: 'none', margin: 0, padding: 0, overflow: 'hidden', backgroundColor: strip.style.borderColor };
                        $horz = $('<div/>').css(common).css({ width: width + 'px', height: '1px' });
                        switch(c) {
                        case 'TL': $horz.css({ bottom: 0, left: 0 }); break;
                        case 'TR': $horz.css({ bottom: 0, right: 0 }); break;
                        case 'BL': $horz.css({ top: 0, left: 0 }); break;
                        case 'BR': $horz.css({ top: 0, right: 0 }); break;
                        }
                        d.appendChild($horz[0]);
                        
                        var $vert = $('<div/>').css(common).css({ top: 0, bottom: 0, width: '1px', height: width + 'px' });
                        switch(c) {
                        case 'TL': $vert.css({ left: width }); break;
                        case 'TR': $vert.css({ right: width }); break;
                        case 'BL': $vert.css({ left: width }); break;
                        case 'BR': $vert.css({ right: width }); break;
                        }
                        d.appendChild($vert[0]);
                    }
                }
            }
        }
    });
};

$.fn.uncorner = function() { 
    if (radius || moz || webkit)
        this.css(radius ? 'border-radius' : moz ? '-moz-border-radius' : '-webkit-border-radius', 0);
    $('div.jquery-corner', this).remove();
    return this;
};

// expose options
$.fn.corner.defaults = {
    useNative: true, // true if plugin should attempt to use native browser support for border radius rounding
    metaAttr:  'data-corner' // name of meta attribute to use for options
};
    
})(jQuery);


