<?php session_start();
/*
Template Name: Contact Page
*/
?>
<?php the_post(); ?>

<?php 
	$mb_ptemplate_settings = array();
	$mb_ptemplate_settings = maybe_unserialize( get_post_meta($post->ID,'mb_ptemplate_settings',true) );
	
	$fullwidth = isset( $mb_ptemplate_settings['mb_fullwidthpage'] ) ? (bool) $mb_ptemplate_settings['mb_fullwidthpage'] : (bool) $mb_ptemplate_settings['mb_fullwidthpage'];
	
	$mb_regenerate_numbers = isset( $mb_ptemplate_settings['mb_regenerate_numbers'] ) ? (bool) $mb_ptemplate_settings['mb_regenerate_numbers'] : (bool) $mb_ptemplate_settings['mb_regenerate_numbers'];
		
	$mb_error_message = '';
	$mb_contact_error = false;
	
	if ( isset($_POST['mb_contactform_submit']) ) {
		if ( !isset($_POST['mb_contact_captcha']) || empty($_POST['mb_contact_captcha']) ) {
			$mb_error_message .= '<p>' . __('Make sure you entered the captcha. ','myband') . '</p>';
			$mb_contact_error = true;
		} else if ( $_POST['mb_contact_captcha'] <> ( $_SESSION['mb_first_digit'] + $_SESSION['mb_second_digit'] ) ) {			
			$mb_numbers_string = $mb_regenerate_numbers ? __('Numbers regenerated.') : '';
			$mb_error_message .= '<p>' . __('You entered the wrong number in captcha. ','myband') . $mb_numbers_string . '</p>';
			
			if ($mb_regenerate_numbers) {
				unset( $_SESSION['mb_first_digit'] );
				unset( $_SESSION['mb_second_digit'] );
			}
			
			$mb_contact_error = true;
		} else if ( empty($_POST['mb_contact_name']) || empty($_POST['mb_contact_email']) || empty($_POST['mb_contact_subject']) || empty($_POST['mb_contact_message']) ){
			$mb_error_message .= '<p>' . __('Make sure you fill all fields. ','myband') . '</p>';
			$mb_contact_error = true;
		}
		
		if ( !is_email( $_POST['mb_contact_email'] ) ) {
			$mb_error_message .= '<p>' . __('Invalid Email. ','myband') . '</p>';
			$mb_contact_error = true;
		}
	} else {
		$mb_contact_error = true;
		if ( isset($_SESSION['mb_first_digit'] ) ) unset( $_SESSION['mb_first_digit'] );
		if ( isset($_SESSION['mb_second_digit'] ) ) unset( $_SESSION['mb_second_digit'] );
	}
	
	if ( !isset($_SESSION['mb_first_digit'] ) ) $_SESSION['mb_first_digit'] = $mb_first_digit = rand(1, 15);
	else $mb_first_digit = $_SESSION['mb_first_digit'];
	
	if ( !isset($_SESSION['mb_second_digit'] ) ) $_SESSION['mb_second_digit'] = $mb_second_digit = rand(1, 15);
	else $mb_second_digit = $_SESSION['mb_second_digit'];
	
	if ( !$mb_contact_error ) {
		$mb_email_to = get_option('myband_email_recipient');
		if($mb_email_to =="") {
			$mb_email_to=get_site_option('admin_email');
		}		
		wp_mail($mb_email_to, sprintf( '[%s] ' . $_POST['mb_contact_subject'], $current_site->site_name ), $_POST['mb_contact_message'],'From: "'. $_POST['mb_contact_name'] .'" <' . $_POST['mb_contact_email'] . '>');
		wp_mail($_POST['mb_contact_email'], sprintf( '[%s] ' . 'mail from '.$mb_email_to , $current_site->site_name ), get_option('myband_email_thankyou_message') ,'From: "Administrator " <' . $mb_email_to . '>');
		$mb_error_message = '<p>' . __('Thanks for contacting us','myband') . '</p>';
	}
?>

<?php get_header(); ?>
	
<div id="content-full">
	<div id="hr">
		<div id="hr-center">
			<div id="intro">
				<div class="center-highlight">
					<div class="container">
						<?php include(TEMPLATEPATH . '/includes/breadcrumbs.php'); ?>
					</div> <!-- end .container -->	
				</div> <!-- end .center-highlight -->
			</div>	<!-- end #intro -->	
		</div> <!-- end #hr-center -->
	</div> <!-- end #hr -->
			
	<div class="center-highlight">
		<div class="container">
	
			<?php if ($fullwidth) { ?>
				<div id="full" class="clearfix">
			<?php } else { ?>
				<div id="content-area" class="clearfix">
					<div id="left-area">
			<?php } ?>
					
					<?php if (get_option('myband_integration_single_top') <> '' && get_option('myband_integrate_singletop_enable') == 'on') echo(get_option('myband_integration_single_top')); ?>
					
					<div class="entry clearfix post<?php if($fullwidth) echo(' full');?>">
						<?php
						  $width = 180;
						  $height = 180;
						  $currUrl=get_permalink();							
						  $classtext = '';
						  $titletext = get_the_title();
						  $thumbnail = get_thumbnail($width,$height,$classtext,$titletext,$titletext,true);
						  $thumb = $thumbnail["fullpath"];
						?>

						<?php if($thumb <> '') { ?>
						<div class="thumbnails-post">
							<div class="gallery-thumb">
							<a href="<?php echo $thumbnail['fullpath']; ?>" class="fancybox">
									<?php print_thumbnail($thumb, true, $titletext, $width, $height, $classtext); ?>
								<span class="overlay"></span>
							</a>
							<div class="gallery-thumb-bottom">
								<div class="left-shadow"></div>
								<div class="bg"></div>
								<div class="right-shadow"></div>
							</div> <!-- end .gallery-thumb-botton -->

							</div> <!-- end .gallery-thumb -->
							</div>
						<?php } ?>
						<h1 class="title"><?php the_title(); ?></h1>
						<?php if($thumb == '') echo('<div class="clear"></div>'); ?>
						<?php the_content(); ?>
						<?php wp_link_pages(array('before' => '<p><strong>'.__('Pages','myband').':</strong> ', 'after' => '</p>', 'next_or_number' => 'number')); ?>
						
						<div id="ev-contact">
							<div id="ev-contact-message"><?php echo($mb_error_message); ?> </div>
							<?php if ( $mb_contact_error ) { ?>
								<form action="<?php echo(get_permalink($post->ID)); ?>" method="post" id="mb_contact_form">
									<div id="mb_contact_left">
										<p class="clearfix">
											<input type="text" name="mb_contact_name" value="<?php if ( isset($_POST['mb_contact_name']) ) echo $_POST['mb_contact_name']; else _e('Name','myband'); ?>" id="mb_contact_name" class="input" />
										</p>
										
										<p class="clearfix">
											<input type="text" name="mb_contact_email" value="<?php if ( isset($_POST['mb_contact_email']) ) echo $_POST['mb_contact_email']; else _e('Email Address','myband'); ?>" id="mb_contact_email" class="input" />
										</p>
										
										<p class="clearfix">
											<input type="text" name="mb_contact_subject" value="<?php if ( isset($_POST['mb_contact_subject']) ) echo $_POST['mb_contact_subject']; else _e('Subject','myband'); ?>" id="mb_contact_subject" class="input" />
										</p>
									</div> <!-- #mb_contact_left -->
									
									<div id="mb_contact_right">
										<p class="clearfix">
											<?php 
												_e('Captcha: ','myband');	
												echo '<br/>';
												echo $mb_first_digit . ' + ' . $mb_second_digit . ' = ';
											?>
											<input type="text" name="mb_contact_captcha" value="<?php if ( isset($_POST['mb_contact_captcha']) ) echo $_POST['mb_contact_captcha']; ?>" id="mb_contact_captcha" class="input" size="2" />
										</p>
									</div> <!-- #mb_contact_right -->
									
									<p class="clearfix">
										<textarea class="input" id="mb_contact_message" name="mb_contact_message"><?php if ( isset($_POST['mb_contact_message']) ) echo $_POST['mb_contact_message']; else _e('Message','myband'); ?></textarea>
									</p>
										
									<input type="hidden" name="mb_contactform_submit" value="mb_contact_proccess" />
									
									<div class="wrap-button">
									<input type="reset" class="submit" id="mb_contact_reset" value="<?php _e('Reset','myband'); ?>" />
									</div>
									<div class="wrap-button">
									<input class="mb_contact_submit submit" type="submit" value="<?php _e('Submit','myband'); ?>" id="mb_contact_submit" />
									</div>
								</form>
							<?php } ?>
						</div> <!-- end #ev-contact -->
						<script type="text/javascript">
						jQuery(document).ready(function() {
								
		var $mb_contact_container = jQuery('#ev-contact'),
		$mb_contact_form = $mb_contact_container.find('form#mb_contact_form'),
		$mb_contact_submit = $mb_contact_container.find('input#mb_contact_submit'),
		$mb_inputs = $mb_contact_form.find('input[type=text],textarea'),
		mb_email_reg = /^([\w-\.]+@([\w-]+\.)+[\w-]{2,4})?$/,
		mb_contact_error = false,
		form_default_values = new Array(),
		$mb_contact_message = jQuery('#ev-contact-message'),
		mb_message = '';
		
		form_default_values['mb_contact_name'] = 'Name';
		form_default_values['mb_contact_email'] = 'Email Address';
		form_default_values['mb_contact_subject'] = 'Subject';
		form_default_values['mb_contact_message'] = 'Message';
			
	$mb_inputs.live('focus', function(){
		if ( jQuery(this).val() === form_default_values[jQuery(this).attr('id')] ) jQuery(this).val("");
	}).live('blur', function(){
		if (jQuery(this).val() === "") jQuery(this).val(form_default_values[jQuery(this).attr('id')]);
	});
	
	$mb_contact_form.live('submit', function() {
		mb_contact_error = false;
		mb_message = '<ul>';
	
		$mb_inputs.removeClass('mb_contact_error');
		
		$mb_inputs.each(function(index, domEle){
			if ( jQuery(domEle).val() === '' || jQuery(domEle).val() === form_default_values[jQuery(domEle).attr('id')] ) {
				jQuery(domEle).addClass('mb_contact_error');
				mb_contact_error = true;
				var default_value = form_default_values[jQuery(domEle).attr('id')];
				if ( default_value === undefined ) default_value = 'Captcha';
				mb_message += '<li>Fill ' + default_value + ' field</li>';
			}
			if ( (jQuery(domEle).attr('id') == 'mb_contact_email') && !mb_email_reg.test(jQuery(domEle).val()) ) {
				jQuery(domEle).removeClass('mb_contact_error').addClass('mb_contact_error');
				mb_contact_error = true;		
				if ( !mb_email_reg.test(jQuery(domEle).val()) ) mb_message += '<li>Invalid email</li>';
			}
		});	
		if ( !mb_contact_error ) {
			$href = jQuery(this).attr('action');	
			$mb_contact_container.fadeTo('fast',0.2).load($href+' #ev-contact', jQuery(this).serializeArray(), function() {
				$mb_contact_container.fadeTo('fast',1);
			});
		}
		mb_message += '</ul>';
		if ( mb_message != '<ul></ul>' )
			$mb_contact_message.html(mb_message);		
		return false;
	});
});
						</script>
						<div class="clear"></div>
						<?php edit_post_link(__('Edit this page','myband')); ?>
					</div> <!-- end .entry -->
					</div> <!-- end #left-area -->
				<?php if (!$fullwidth) get_sidebar(); ?>
			</div> <!-- end #content-area -->
		</div> <!-- end .container -->					
<?php get_footer(); ?>