<?php
add_action( 'admin_enqueue_scripts', 'upload_theme_scripts' );
function upload_theme_scripts( $hook_suffix ) {
	wp_register_style('myStyleSheets', get_bloginfo('template_directory').'/theme-assets/css/custom-admin-style.css');
    wp_enqueue_style('myStyleSheets');
	wp_register_script('jquery.ui.datepicker', get_bloginfo('template_directory').'/theme-assets/js/jquery.ui.datepicker.js', array('jquery'));
	wp_register_script('jquery.jqplot', get_bloginfo('template_directory').'/theme-assets/js/jquery.jqplot.js', array('jquery'));
	wp_register_script('jqplot.dateAxisRenderer.min', get_bloginfo('template_directory').'/theme-assets/js/jqplot.dateAxisRenderer.min.js', array('jquery'));
	wp_register_script('jqplot.canvasTextRenderer.min', get_bloginfo('template_directory').'/theme-assets/js/jqplot.canvasTextRenderer.min.js', array('jquery'));
	wp_register_script('jqplot.canvasAxisTickRenderer.min', get_bloginfo('template_directory').'/theme-assets/js/jqplot.canvasAxisTickRenderer.min.js', array('jquery'));
	wp_register_script('jqplot.highlighter.min', get_bloginfo('template_directory').'/theme-assets/js/jqplot.highlighter.min.js', array('jquery'));
	wp_register_script('jqplot.cursor.min', get_bloginfo('template_directory').'/theme-assets/js/jqplot.cursor.min.js', array('jquery'));
	wp_enqueue_script('jquery.ui.datepicker');
	wp_enqueue_script('jquery.jqplot');
	wp_enqueue_script('jqplot.dateAxisRenderer.min');
	wp_enqueue_script('jqplot.canvasTextRenderer.min');
	wp_enqueue_script('jqplot.canvasAxisTickRenderer.min');
	wp_enqueue_script('jqplot.highlighter.min');
	wp_enqueue_script('jqplot.cursor.min');
}


function ds_get_category_list($valueID, $valueDV) { //Get category list and display it as a dropdown list
		
	echo '<select name="dropdown_list_category" onchange="document.getElementById(' . "'" . $valueID . "'" . ').value=this.options[this.selectedIndex].value;">';
	echo '<option value="">' . esc_attr($valueDV) . '</option>';
	
	$categories =  get_categories(); 
	foreach ($categories as $cat) :
	
		$option = '<option value="' . $cat->cat_ID . '"';
		
		if ( $cat->cat_ID == get_option($valueID) ) :
			$option .= ' selected="selected">';
		else :
			$option .= ' >';
		endif;
		
		$option .= $cat->cat_name;
		$option .= ' (' . $cat->category_count . ')';
		$option .= '</option>';
		echo $option;
		
	endforeach;
	
	echo '</select>';
	
}

function ds_get_page_list($valueID, $valueDV) { //Get page list and display it as a dropdown list
		
	echo '<select name="dropdown_list_page" onchange="document.getElementById(' . "'" . $valueID . "'" . ').value=this.options[this.selectedIndex].value;">';
	echo '<option value="">' . esc_attr($valueDV) . '</option>';
	
	$pages =  get_pages(); 
	foreach ($pages as $pagg) :
	
		$option = '<option value="' . $pagg->ID . '"';
		
		if ( $pagg->ID == get_option($valueID) ) :
			$option .= ' selected="selected">';
		else :
			$option .= ' >';
		endif;
		
		$option .= $pagg->post_title;
		$option .= '</option>';
		echo $option;
		
	endforeach;
	
	echo '</select>';
	
}

function ds_get_ao($the_value) { //Get the value of an admin option
        global $shortname;
        $the_value_raw = get_option($shortname . $the_value);
        return $the_value_raw;
    }

function ds_ao($the_value) { //Print the value of an admin option
        global $shortname;
        $the_value_raw = get_option($shortname . $the_value);
        echo $the_value_raw;
    }
add_filter( 'avatar_defaults', 'newgravatar' );

function newgravatar ($avatar_defaults) {
    $myavatar = get_bloginfo('template_directory') . '/images/avatar.jpg';
    $avatar_defaults[$myavatar] = "Build Internet";
    return $avatar_defaults;
}

/**
 * Add "first" and "last" CSS classes to dynamic sidebar widgets. Also adds numeric index class for each widget (widget-1, widget-2, etc.)
 */
function widget_first_last_classes($params) {

	global $my_widget_num; // Global a counter array
	$this_id = $params[0]['id']; // Get the id for the current sidebar we're processing
	$arr_registered_widgets = wp_get_sidebars_widgets(); // Get an array of ALL registered widgets	

	if(!$my_widget_num) {// If the counter array doesn't exist, create it
		$my_widget_num = array();
	}

	if(!isset($arr_registered_widgets[$this_id]) || !is_array($arr_registered_widgets[$this_id])) { // Check if the current sidebar has no widgets
		return $params; // No widgets in this sidebar... bail early.
	}

	if(isset($my_widget_num[$this_id])) { // See if the counter array has an entry for this sidebar
		$my_widget_num[$this_id] ++;
	} else { // If not, create it starting with 1
		$my_widget_num[$this_id] = 1;
	}

	$class = 'class="widget-' . $my_widget_num[$this_id] . ' '; // Add a widget number class for additional styling options

	if($my_widget_num[$this_id] == 1) { // If this is the first widget
		$class .= 'widget-first ';
	} elseif($my_widget_num[$this_id] == count($arr_registered_widgets[$this_id])) { // If this is the last widget
		$class .= 'widget-last ';
	}

	$params[0]['before_widget'] = str_replace('class="', $class, $params[0]['before_widget']); // Insert our new classes into "before widget"

	return $params;

}
add_filter('dynamic_sidebar_params','widget_first_last_classes');	

?>