<?php
$mybandtheme_general_font_options = array (
	array(
		'type' => 'open'
	),
	array(
		'name' => 'Font Settings',
		'desc'=>'You can use the font type you would like to be used throughout your website.<br/>These fonts are present on most Windows and Mac computers, so you can use them with confidence.',
		'type' => 'options_title'
	),
	array(
		"name" => __("<hr><br/>Font family",'myband_admin'),
		"desc" => '',
		"id" => "font_family",
		"default" => 'Arial,Helvetica,Garuda,sans-serif',
		"options" => array(
			'Arial,Helvetica,sans-serif' => 'Arial, Helvetica, sans-serif',
			'Verdana,Geneva,sans-serif' => 'Verdana, Geneva, sans-serif',
			'Lucida Sans Unicode,Lucida Grande,Garuda,sans-serif' => 'Lucida Sans Unicode, Lucida Grande, sans-serif',
			'Georgia,serif' => 'Georgia, serif',
			'Palatino Linotype,Book Antiqua,Palatino,serif' => 'Palatino Linotype, Book Antiqua, Palatino, serif',
			'Tahoma,Geneva,sans-serif' => 'Tahoma, Geneva, sans-serif',
			'Trebuchet MS,Helvetica,sans-serif' => 'Trebuchet MS, Helvetica, sans-serif',
			'Times New Roman,Times,serif' => 'Times New Roman, Times, serif',
		),
		"type" => "select_font",
	),
	array(
		'name' => 'Line height (in pixels)',
		'desc' => 'Line height:',
		'id' => 'line_height',
		'type' => 'text',
		'default_value' => '21'
	),
	array(
		'type' => 'close'
	)
);

$mybandtheme_cufon_options = array (
	array(
		'type' => 'open'
	),
	array(
		'name' => 'Cufón Settings',
		'desc'=>'MyBandTheme uses Cufón to make the display of certain text elements (titles, buttons, etc.) prettier than standard system fonts.<br/> Please choose which Cufón font you would like to use.',
		'type' => 'options_title'
	),
	array(
		"name" => __("<hr><br/>Turn On/Off Cufón"),
		"desc" => 'Turn off Cufón and just use the system font specified on the general fonts settings tab.',
		"id" => "turn_cufon",
		"default" => 'on',
		"options" => array(
			'on' => 'On',
			'off' => 'Off'
			
		),
		"type" => "select"),
	
	array(
		"name" => __("Please select Cufón font",'myband_admin'),
		"desc" => '',
		"id" => "cufon_font",
		"default" => '',
		"options" => array(
			'' => 'Select one',
			'capsuula.cufonfonts.js' => 'CapsuulaRegular',
			'caviar-dreams.cufonfonts.js' => 'Caviar Dreams',
			'colaborate.cufonfonts.js' => 'Colaborate',
			'comfortaa.cufonfonts.js' => 'Comfortaa',
			'cuprum.cufonfonts.js' => 'Cuprum',
			'droid-sans.cufonfonts.js' => 'Droid Sans',
			'existence-light.cufonfonts.js' => 'Existence-Light',
			'josefin-sans-std.cufonfonts.js' => 'Josefin Sans Std Light',
			'lane.cufonfonts.js' => 'Lane - Narrow',
			'LTBrewery_Light_400.font.js' => 'LTBrewery Light',
			'myriad-pro.cufonfonts.js' => 'Myriad Pro Regular',
			'myriad-pro-con.cufonfonts.js' => 'Myriad Pro Condensed',
			'perpetua.cufonfonts.js' => 'Perpetua',
			'quicksand.cufonfonts.js' => 'Quicksand Book Regular',
			'raleway.cufonfonts.js' => 'Raleway',
			'sansation.cufonfonts.js' => 'Sansation Light',
			'springsteel-light.cufonfonts.js' => 'Springsteel Light',
			'yanone-kaffeesatz.cufonfonts.js' => 'Yanone Kaffeesatz Light',
			'japanese.cufonfonts.js' => 'Japanese',
			'ming-imperial.cufonfonts.js' => 'Chinese',
		),
		"type" => "select_cufon",
	),
	array(
		'type' => 'close'
	)
);


/**
 * displays a select
 */
function select($value) {
	if (isset($value['target'])) {
		if (isset($value['options'])) {
			$value['options'] = $value['options'] + $this->get_select_target_options($value['target']);
		} else {
			$value['options'] = $this->get_select_target_options($value['target']);
		}
	}
	
	echo '<select name="' . $value['id'] . '" id="' . $value['id'] . '">';
	
	if(isset($value['prompt'])){
		echo '<option value="">'.$value['prompt'].'</option>';
	}
	if (isset($value['options'])) {
		foreach($value['options'] as $key => $option) {
			echo "<option value='" . $key . "'";
			if (get_option($value['id'])) {
				if (stripslashes(get_option($value['id'])) == $key) {
					echo ' selected="selected"';
				}
			} else if ($key == $value['default']) {
				echo ' selected="selected"';
			}
			echo '>' . $option . '</option>';
		}
	}
	if (isset($value['page'])){
		$depth = $value['page'];
		$selected = isset($this->saved_options[$value['id']])?stripslashes($this->saved_options[$value['id']]):$value['default'];
		$args = array(
			'depth' => $depth, 'child_of' => 0,
			'selected' => $selected, 'echo' => 1,
			'name' => 'page_id', 'id' => '',
			'show_option_none' => '', 'show_option_no_change' => '',
			'option_none_value' => ''
		);
		$pages = get_pages($args);
		
		echo walk_page_dropdown_tree($pages,$depth,$args);
	}
	
	echo '</select><br />';
}

function mybandtheme_general_font_options() {
   global $mybandtheme_general_font_options;
	?>
   <div class="wrap">
	<form method="post">
	<?php
	foreach ($mybandtheme_general_font_options as $value) :
		switch ( $value['type'] ) :
			case 'open' :
				?><ul class="ds_admin">
	            <?php
				if ( $_REQUEST['reset'] ) echo '<li><div id="message" class="updated fade"><p><strong>Settings Reset.</strong></p></div></li>';
				if ( $_REQUEST['saved'] ) echo '<li><div id="message" class="updated fade"><p><strong>Settings Saved.</strong></p></div></li>';
				?>
				<?php
			break;
			case 'select' :
				?><h3><?php echo $value['name']; ?></h3><?php
				if(isset($value['desc'])){
					echo '<p class="description">' . $value['desc'] . '</p>';
				}
				select($value);
			break;
			case 'select_font' :
				?><h3><?php echo $value['name']; ?></h3><?php
				if(isset($value['desc'])){
					echo '<p class="description">' . $value['desc'] . '</p>';
				}
				$selecttedvalue = get_option( $value['id'], $value['default_value']  );
				select($value);?>
				<h4><?php _e('Font Preview','myband_admin');?></h4>
				<div id="<?php echo $value['id']; ?>_prev" style="width:600px;font-size:20px;padding-bottom:20px;font-family:<?php echo $selecttedvalue;?>; line-height:1.2em;">
				This is a preview of the chosen font used in MyBandTheme.<br/>
				Some numbers: 1234567890 and characters: +!?=().<br/>
				UPPERCASE TEXT, as well as <strong>bold text</strong> and <em>italics being used.</em></div>
				<script type="text/javascript">
				 jQuery(document).ready(function() {
				   jQuery("#<?php echo $value['id']; ?>").change(function() {
					 jQuery("#<?php echo $value['id']; ?>_prev").css("font-family", jQuery("#<?php echo $value['id']; ?>").val());

				   });
				 });
				</script>
				<?php 
			break;
			case 'text':
				?>
				<li>
				<h3><?php echo $value['name']; ?></h3>
		            <?php if ( get_option($value['id']) == '' ) : update_option($value['id'], $value['default_value']); endif; ?>
                    <p><label for="<?php echo $value['id']; ?>"><?php echo $value['desc']; ?></label> <input name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" type="text" value="<?php echo htmlspecialchars(get_option( $value['id'], $value['default_value']  )); ?>" /></p>
	            </li>
				<?php
			break;
			case 'options_title':
				?>
				<li>
					<div class="icon32" id="icon-options-fonts"><br/></div>
                    <h2><?php echo $value['name']; ?></h2>
					<?php echo '<p class="description">' . $value['desc'] . '</p>'; ?>
	            </li>
				<?php
			break;
			case 'close':
				?></ul><?php
			break;
		endswitch;
	endforeach;
	?>   
    <p class="submit" style="float: left;">
        <input name="save" type="submit" value="Save changes" class="button-primary" />
        <input type="hidden" name="action" value="save" />
    </p>
	</form>
   
	<form method="post">
    <p class="submit" style="float: left;">
        <input name="reset" type="submit" value="Reset"/>
        <input type="hidden" name="action" value="reset" />
    </p>
	</form>
    
	</div>
	<?php
}

function mybandtheme_cufon_options() {
   global $mybandtheme_cufon_options;
	?>
   <div class="wrap">
	<form method="post">
	
	<?php
	foreach ($mybandtheme_cufon_options as $value) :
		switch ( $value['type'] ) :
		case 'open' :
			?><ul class="ds_admin">
            <?php
			if ( $_REQUEST['reset'] ) echo '<li><div id="message" class="updated fade"><p><strong>Settings Reset.</strong></p></div></li>';
			if ( $_REQUEST['saved'] ) echo '<li><div id="message" class="updated fade"><p><strong>Settings Saved.</strong></p></div></li>';
			?>
			<?php
		break;
			case 'options_title':
				?>
				<li>
					<div class="icon32" id="icon-options-cufon"><br/></div>
                    <h2><?php echo $value['name']; ?></h2>
					<?php echo '<p class="description">' . $value['desc'] . '</p>'; ?>
				
	            </li>
				<?php
			break;
			case 'select' :
				?><h3><?php echo $value['name']; ?></h3><?php
				if(isset($value['desc'])){
					echo '<p class="description">' . $value['desc'] . '</p>';
				}
				select($value);
			break;
			case 'select_cufon' :
				?><h3><?php echo $value['name']; ?></h3><?php
				if(isset($value['desc'])){
					echo '<p class="description">' . $value['desc'] . '</p>';
				}
				$selecttedvalue = get_option( $value['id'], $value['default_value']  );
				$fontname = get_option( $value['id'], $value['default_value']  );
				select($value);?>
				<h4><?php _e('Font Preview','myband_admin');?></h4>
				<iframe scrolling="no" id="cufon_preview" src="" width="100%" height="70">
				</iframe>
				<script type="text/javascript">
				 jQuery(document).ready(function() {
					if(jQuery("#<?php echo $value['id']; ?> option:selected").text() != 'Select one'){
					 jQuery("#cufon_preview").attr("src", "<?php bloginfo('stylesheet_directory'); ?>/includes/cufon_preview.php?font=<?php bloginfo('stylesheet_directory'); ?>/js/fonts/"+jQuery("#<?php echo $value['id']; ?>").val()+"&fontname="+jQuery("#<?php echo $value['id']; ?> option:selected").text());
					}
					
				   jQuery("#<?php echo $value['id']; ?>").change(function() {
					if(jQuery("#<?php echo $value['id']; ?> option:selected").text() != 'Select one'){
					 jQuery("#cufon_preview").attr("src", "<?php bloginfo('stylesheet_directory'); ?>/includes/cufon_preview.php?font=<?php bloginfo('stylesheet_directory'); ?>/js/fonts/"+jQuery("#<?php echo $value['id']; ?>").val()+"&fontname="+jQuery("#<?php echo $value['id']; ?> option:selected").text());
					}
				   });
				 });
				</script>
				<?php
			break;
			
			case 'close':
				?></ul><?php
			break;

		endswitch;
	endforeach;
	?>
	
    <p class="submit" style="float: left;">
        <input name="save" type="submit" value="Save changes" class="button-primary" />
        <input type="hidden" name="action" value="save" />
    </p>
	</form>
   
	<form method="post">
    <p class="submit" style="float: left;">
        <input name="reset" type="submit" value="Reset"/>
        <input type="hidden" name="action" value="reset" />
    </p>
	</form>
    
	</div>
	<?php
}

function mybandtheme_font_options() {
    global $mybandtheme_general_font_options;
	global $mybandtheme_cufon_options;
		if ( $_GET['page'] == basename(__FILE__) ) :
			$tab='';
				if(isset($_GET['tab'])) {
					$tab='&tab='.$_GET['tab']; 
				}
			if ( 'save' == $_REQUEST['action'] ) :
				if($_GET['tab']!='cufon') {
					foreach ( $mybandtheme_general_font_options as $value ) :
						if ( isset( $_REQUEST[ $value['id'] ] ) ) :
							update_option( $value['id'], stripslashes_deep($_REQUEST[ $value['id'] ]) );
						else :
							delete_option( $value['id'] );
						endif;
					endforeach;
					}
				else {
					foreach ( $mybandtheme_cufon_options as $value ) :
						if ( isset( $_REQUEST[ $value['id'] ] ) ) :
							update_option( $value['id'], stripslashes_deep($_REQUEST[ $value['id'] ]) );
						else :
							delete_option( $value['id'] );
						endif;
					endforeach;
				}
				header('Location: admin.php?page=' . basename(__FILE__) .  $tab .'&saved=true');
				die;
			elseif ( 'reset' == $_REQUEST['action'] ) :
								
				foreach ( $mybandtheme_general_font_options as $value ) :
					delete_option( $value['id'] );
				endforeach;
				foreach ( $mybandtheme_cufon_options as $value ) :
					delete_option( $value['id'] );
				endforeach;
				header('Location: admin.php?page=' . basename(__FILE__) .  $tab  .'&reset=true');
				die;
			endif;
		endif;
	add_submenu_page( 'functions.php', 'Font Settings', 'Font Settings', 8, basename(__FILE__), 'sa_theme_home_page' );
}

add_action('admin_menu', 'mybandtheme_font_options');

function mybandtheme_admin_tabs( $current = 'general' ) {
    $tabs = array( 'general' => 'General', 'cufon' => 'Cufón' );
    $links = array();

    foreach( $tabs as $tab => $name ) :
        if ( $tab == $current ) :
            $links[] = "<a class='nav-tab nav-tab-active' href='?page=options-5.php&tab=$tab'>$name</a>";
        else :
            $links[] = "<a class='nav-tab' href='?page=options-5.php&tab=$tab'>$name</a>";
        endif;
    endforeach;
    echo '<div id="adminTabs">';
    foreach ( $links as $link )
        echo $link;
    echo '</div>';
}

function mytheme_fontface_options(){
	echo 'Font Face settings go here.';
}
// Function to generate options page
function sa_theme_home_page() {
	global $pagenow;
	if ( $pagenow == 'admin.php' && $_GET['page'] == 'options-5.php' ) :
	    if ( isset ( $_GET['tab'] ) ) :
	        $tab = $_GET['tab'];
	    else:
	        $tab = 'general';
	    endif;
		mybandtheme_admin_tabs($tab);
	    switch ( $tab ) :
	        case 'general' :
	            mybandtheme_general_font_options();
	            break;
	        case 'cufon' :
	            mybandtheme_cufon_options();
	            break;
	    endswitch;
	endif;
}
?>