<?php
global $ds_custom_field_key;
$ds_prepare_custom_fields = array (
	
	array(
		'name' => 'Album Authors',
		'desc' => 'The authors of the album:',
		'id' => $ds_custom_field_key . 'album_author',
		'type' => 'ec_medium_url',
		'default_value' => ''
	),
	
	array(
		'name' => 'Album Release Date',
		'desc' => 'Release date of the album:',
		'id' => $ds_custom_field_key . 'album_year',
		'type' => 'ec_single_colum',
		'default_value' => ''
	),
	array(
		'name' => 'Album Price',
		'desc' => 'Leave empty to disable sale of album:',
		'id' => $ds_custom_field_key . 'album_price',
		'type' => 'ec_single_colum_end',
		'default_value' => ''
	),
	array(
		'name' => 'Album Download URL',
		'desc' => '',
		'id' => $ds_custom_field_key . 'album_url',
		'type' => 'ec_full_url',
		'default_value' => ''
	),
	array(
		'name' => 'Exclude album from Album list',
		'desc' => 'Use this to create custom playlists for the Music Player Widget. This album won\'t be listed on the Album List page.',
		'id' => $ds_custom_field_key . 'album_excl',
		'type' => 'ec_checkbox',
		'default_value' => ''
	),
	array(
		'name' => 'Song Ordering',
		'desc' => 'Create songs and drag and drop to change their display order.',
		'id' => $ds_custom_field_key . 'add_song',
		'type' => 'ec_hidden',
		'default_value' => ''
	),
	array(
		'name' => 'Songs on the album',
		'desc' => 'The songs on the album.',
		'id' => $ds_custom_field_key . 'id_song',
		'type' => 'ec_multiple_song',
		'default_value' => '1'
	)
);

function ds_write_custom_fields() {
	global $post, $ds_prepare_custom_fields;
	echo'<table cellspacing="0" id="inactive-plugins-table" style="width: 100%;">
			<tbody>';
	
			foreach ( $ds_prepare_custom_fields as $custom_field ) :
				switch ( $custom_field['type'] ) :
					case 'ec_medium_url':
						?>
                  
	               <?php $temp = get_post_meta($post->ID, $custom_field['id'] . '_value', true); ?>
                  
                  <tr>
                     <td colspan="2">
                        <p><strong><?php echo $custom_field['name']; ?></strong></p>
                        <p><?php echo $custom_field['desc']; ?></p>
                        <p> <input style="width: 100%" name="<?php echo $custom_field['id'] . '_value'; ?>" type="text" value="<?php if ( $temp != "") { echo $temp; } else { echo $custom_field['default_value']; } ?>" /></p>
                        <input name="<?php echo $custom_field['id'] . '_noncename'; ?>" id="<?php echo $custom_field['id'] . '_noncename'; ?>" type="hidden" value="<?php echo wp_create_nonce( plugin_basename(__FILE__) ) ?>"/>
                     </td>
						<?php
					break;
					
					case 'ec_full_url':
						?>
	               <?php $temp = get_post_meta($post->ID, $custom_field['id'] . '_value', true); ?>
                  <tr>
                     <td colspan="4" >
                        <p><strong><?php echo $custom_field['name']; ?></strong></p>
                        <p><?php echo 'Using the <a href="media-upload.php?post_id='.$post->ID.'&type=image&TB_iframe=1&width=640&height=522" target="" class="thickbox">media library</a>, upload and paste the file URL here. Alternatively, to sell album on iTunes or Amazon MP3, enter the URL here.'; ?></p>
                        <p> <input style="width: 100%" name="<?php echo $custom_field['id'] . '_value'; ?>" type="text" value="<?php if ( $temp != "") { echo $temp; } else { echo $custom_field['default_value']; } ?>" /></p>
                        <input name="<?php echo $custom_field['id'] . '_noncename'; ?>" id="<?php echo $custom_field['id'] . '_noncename'; ?>" type="hidden" value="<?php echo wp_create_nonce( plugin_basename(__FILE__) ) ?>"/>

                     </td>
					 </tr>
						<?php
					break;
					
                    case 'ec_checkbox':
						?>
	               <?php $temp = get_post_meta($post->ID, $custom_field['id'] . '_value', true); ?>
                    <td colspan="4">
                        <p><strong><?php echo $custom_field['name']; ?></strong></p>
                        <p><label for="<?php echo $custom_field['id'] . '_value'; ?>">
						<input type="checkbox" id="<?php echo $custom_field['id'] . '_value'; ?>" name="<?php echo $custom_field['id'] . '_value'; ?>" value="yes" <?php if ( $temp == "yes") { echo ' checked="checked"'; }?>" /> <?php echo $custom_field['desc']; ?></label>
						</p>
                        <input name="<?php echo $custom_field['id'] . '_noncename'; ?>" id="<?php echo $custom_field['id'] . '_noncename'; ?>" type="hidden" value="<?php echo wp_create_nonce( plugin_basename(__FILE__) ) ?>"/>
                     </td>
						<?php
					break;
										
                    case 'ec_single_colum':
						?>
	               <?php $temp = get_post_meta($post->ID, $custom_field['id'] . '_value', true); ?>
                    <td>
                        <p><strong><?php echo $custom_field['name']; ?></strong></p>
                        <p><?php echo $custom_field['desc']; ?></p>
                        <p><input style="width: 100%" name="<?php echo $custom_field['id'] . '_value'; ?>" type="text" value="<?php if ( $temp != "") { echo $temp; } else { echo $custom_field['default_value']; } ?>" /> </p>
                        <input name="<?php echo $custom_field['id'] . '_noncename'; ?>" id="<?php echo $custom_field['id'] . '_noncename'; ?>" type="hidden" value="<?php echo wp_create_nonce( plugin_basename(__FILE__) ) ?>"/>
                     </td>
						<?php
					break;
					
					 case 'ec_single_colum_end':
						?>
	               <?php $temp = get_post_meta($post->ID, $custom_field['id'] . '_value', true); ?>
                    <td>
                        <p><strong><?php echo $custom_field['name']; ?></strong></p>
                        <p><?php echo $custom_field['desc']; ?></p>
                        <p><input style="width: 100%" name="<?php echo $custom_field['id'] . '_value'; ?>" type="text" value="<?php if ( $temp != "") { echo $temp; } else { echo $custom_field['default_value']; } ?>" /> </p>
                        <input name="<?php echo $custom_field['id'] . '_noncename'; ?>" id="<?php echo $custom_field['id'] . '_noncename'; ?>" type="hidden" value="<?php echo wp_create_nonce( plugin_basename(__FILE__) ) ?>"/>
                     </td>
					 </tr>
					 	<?php
					break;
					case 'ec_hidden':
						?>
	               <?php $temp = get_post_meta($post->ID, $custom_field['id'] . '_value', true); ?>
					<tr >
                     <td colspan="4" >
						<script type="text/javascript">
			
		/* when the DOM is ready */
		jQuery(document).ready(function() {
			/* grab important elements */
			var sortInput = jQuery('#<?php echo $custom_field['id']; ?>');
			var submit = jQuery('#autoSubmit');
			var messageBox = jQuery('#message-box');
			var list = jQuery('#sortable-list');
			/* create requesting function to avoid duplicate code */
			var request = function() {
				
			};
			/* worker function */
			var fnSubmit = function(save) {
				var sortOrder = [];
				list.children('li').each(function(){
					sortOrder.push(jQuery(this).data('id'));
				});
				sortInput.val(sortOrder.join(','));
				if(save) {
					request();
				}
			};
			/* store values */
			list.children('li').each(function() {
				var li = jQuery(this);
				li.data('id',li.attr('title')).attr('title','');
			});
			/* sortables */
			list.sortable({
				opacity: 0.7,
				update: function() {
					fnSubmit(submit[0].checked);
				}
			});
			list.disableSelection();
			/* ajax form submission */
			jQuery('#dd-form').bind('submit',function(e) {
				if(e) e.preventDefault();
				fnSubmit(true);
			});
		});
	

						</script>
                        <p><strong><?php echo $custom_field['name']; ?></strong></p>
						<p><?php echo $custom_field['desc'];?></p>
						<input type="checkbox" style="display:none;" value="1" name="autoSubmit" id="autoSubmit" <?php if($_POST['autoSubmit']) { echo 'checked="checked"'; } ?> />
                        <ul id="sortable-list">
							<?php 
							$add_song_id=explode(",", get_post_meta($post->ID,'add_song_value', true));
							foreach ($add_song_id as $value) {
									if($value!="") {
									echo '<li class="list-song-item'.$value.'" title="'.$value.'">'.get_post_meta($post->ID,'song_title'.$value, true).'</li>';
									}
								}
							?>
						</ul>
                        <p> <input id= "<?php echo $custom_field['id']; ?>" name="<?php echo $custom_field['id'] . '_value'; ?>" type="hidden" value="<?php echo $temp;?>" /></p>
                        <input name="<?php echo $custom_field['id'] . '_noncename'; ?>" id="<?php echo $custom_field['id'] . '_noncename'; ?>" type="hidden" value="<?php echo wp_create_nonce( plugin_basename(__FILE__) ) ?>"/>
                     </td>
                    </tr>
						<?php
					break;
					case 'ec_multiple_song':
						?>
	               <?php $temp = get_post_meta($post->ID, $custom_field['id'] . '_value', true); ?>
                    <tr>
						<td colspan="4">
						<script type="text/javascript">
							function addFormField() {
								var id = document.getElementById("id_song").value;
								jQuery("#inactive-plugins-table").append("<tr class='srow" + id + "'><td colspan='4'><hr></td></tr><tr class='srow" + id + "'><td colspan='4' align='right'><a href='#' style='' onclick='removeFormField(" + id + "); return false;'>Remove</a></td></tr><tr class='srow" + id + "'><td colspan='2'  width='50%'><p><strong>Song Title</strong></p><p><input style='width:100%' name='song_title" + id + "' id='song_title" + id + "' type='text'></p></td><td width='25%'><p><strong>Song Price</strong></p><p><input style='width:100%' name='song_price" + id + "' id='song_price" + id + "' type='text'></p></td><td width='25%'><p><strong>Play Count</strong></p><p><input style='width:100%' name='song_count" + id + "' id='song_count" + id + "' type='text'></p></td></tr><tr class='srow" + id + "' ><td colspan='2' width='50%'><p><strong>Preview URL</strong></p><p><input style='width:100%' name='song_preview" + id + "' id='song_preview" + id + "' type='text'></p></td><td colspan='2' width='50%'><p><strong>Full URL</strong></p><p><input style='width:100%' name='song_full" + id + "' id='song_full" + id + "' type='text'></p></td></tr><tr class='srow" + id + "' ><td colspan='2' width='50%'><p><strong>iTunes URL</strong></p><p><input style='width:100%' name='song_itunes" + id + "' id='song_itunes" + id + "' type='text'></p></td><td colspan='2' width='50%'><p><strong>Amazon MP3 URL</strong></p><p><input style='width:100%' name='song_amazon" + id + "' id='song_amazon" + id + "' type='text'></p></td></tr><tr class='srow" + id + "' ><td colspan='4'><p><strong>Song Lyrics</strong></p><p><textarea style='width:100%' name='song_lyrics" + id + "' id='song_lyrics" + id + "' rows='5'></textarea></p></td></tr>");
							
								if(jQuery("#add_song").val() == ""){
								jQuery("#add_song").val(id);
								}
								else {
								jQuery("#add_song").val(jQuery("#add_song").val()+","+id);
								}
								
								id = (id-1) + 2;
								document.getElementById("id_song").value = id;
							}
							function removeFormField(id) {
								jQuery(".srow"+id).remove();
								jQuery(".list-song-item"+id).remove();
								
								if(jQuery("#remove_song").val() == "" ) {
								jQuery("#remove_song").val(id);
								}
								else {
								jQuery("#remove_song").val(jQuery("#remove_song").val()+","+id);
								}
								jQuery("#add_song").val(jQuery("#add_song").val().replace(","+id,""));
							}

						</script>
							<h3><?php echo $custom_field['name']; ?></h3>
							 <p><?php echo $custom_field['desc']; ?></p>
							<input id="<?php echo $custom_field['id'] ; ?>" name="<?php echo $custom_field['id'] . '_value'; ?>" type="hidden" value="<?php if ( $temp != "") { echo $temp; } else { echo $custom_field['default_value']; } ?>" />
							<input name="<?php echo $custom_field['id'] . '_noncename'; ?>" id="<?php echo $custom_field['id'] . '_noncename'; ?>" type="hidden" value="<?php echo wp_create_nonce( plugin_basename(__FILE__) ) ?>"/>
							
							<input id="remove_song" name="remove_song" value="" type="hidden">
							<p><a href="#" onclick="addFormField(); return false;" >Add new song</a></p>
							</td>
						</tr>
						<?php
							$add_song_id=explode(",", get_post_meta($post->ID,'add_song_value', true));
							foreach ($add_song_id as $value) {
							if($value !="") {
						?>
							<tr class='srow<?php echo $value; ?>' >
								<td colspan='4'>
									<hr />
								</td>
							</tr>
							<tr class='srow<?php echo $value; ?>' >
								<td colspan='4' align='right'>
									<a href='#' style='' onclick='removeFormField(<?php echo $value; ?>); return false;'>Remove</a>
								</td>
							</tr>
							<tr class='srow<?php echo $value; ?>'>
								<td colspan='2' width="50%">
									<p><strong>Song Title</strong></p><p><input style='width:100%' name='song_title<?php echo $value; ?>' id='song_title<?php echo $value; ?>' type='text' value='<?php echo htmlspecialchars(get_post_meta($post->ID,'song_title'.$value, true), ENT_QUOTES); ?>'/></p>
								</td>
								<td width="25%">
									<p><strong>Song Price</strong></p><p><input style='width:100%' name='song_price<?php echo $value; ?>' id='song_price<?php echo $value; ?>' type='text' value='<?php echo get_post_meta($post->ID,'song_price'.$value, true);?>'></p>
								</td>
								<td width="25%">
									<p><strong>Play Count</strong></p><p><input style='width:100%' name='song_count<?php echo $value; ?>' id='song_count<?php echo $value; ?>' type='text' value='<?php echo get_post_meta($post->ID,'song_count'.$value, true);?>'></p>
								</td>
							</tr>
							<tr class='srow<?php echo $value; ?>' >
								<td colspan='2' width="50%">
									<p><strong>Preview URL</strong></p><p><input style='width:100%' name='song_preview<?php echo $value; ?>' id='song_preview<?php echo $value; ?>' type='text' value='<?php echo get_post_meta($post->ID,'song_preview'.$value, true);?>'/></p>
								</td>
								<td colspan='2' width="50%">
									<p><strong>Full URL</strong></p><p><input style='width:100%' name='song_full<?php echo $value; ?>' id='song_full<?php echo $value; ?>' type='text' value='<?php echo get_post_meta($post->ID,'song_full'.$value, true);?>'/></p>
								</td>
							</tr>
							<tr class='srow<?php echo $value; ?>' >
								<td colspan='2' width="50%">
									<p><strong>iTunes URL</strong></p><p><input style='width:100%' name='song_itunes<?php echo $value; ?>' id='song_itunes<?php echo $value; ?>' type='text' value='<?php echo get_post_meta($post->ID,'song_itunes'.$value, true);?>'/></p>
								</td>
								<td colspan='2' width="50%">
									<p><strong>Amazon MP3 URL</strong></p><p><input style='width:100%' name='song_amazon<?php echo $value; ?>' id='song_amazon<?php echo $value; ?>' type='text' value='<?php echo get_post_meta($post->ID,'song_amazon'.$value, true);?>'/></p>
								</td>	
							</tr>
							<tr class='srow<?php echo $value; ?>' >
								<td colspan='4'>
									<p><strong>Song Lyrics</strong></p><p><textarea style='width:100%' name='song_lyrics<?php echo $value; ?>' id='song_lyrics<?php echo $value; ?>' rows='5'><?php echo get_post_meta($post->ID,'song_lyrics'.$value, true);?></textarea></p>
								</td>	
							</tr>
						<?php }
						}
					break;	
				endswitch;
			endforeach;
	echo'</tbody>	
		</table>';
}

function ds_init_custom_fields() {
	if ( function_exists('add_meta_box') ) :
		add_meta_box( 'new-meta-boxes', 'Theme Custom Fields', 'ds_write_custom_fields', 'album', 'normal', 'high' );
	endif;
}

function ds_save_custom_fields( $post_id ) {
		global $post, $ds_prepare_custom_fields, $ds_custom_field_key;
		foreach ( $ds_prepare_custom_fields as $custom_field ) :
			// verify this came from the our screen and with proper authorization, because save_post can be triggered at other times
			if ( !wp_verify_nonce( $_POST[$custom_field['id'] . '_noncename'], plugin_basename(__FILE__) ) ) :
			 return $post_id;
			endif;
			// verify if this is an auto save routine. If it is our form has not been submitted, so we dont want to do anything
			if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE ) return $post_id;
			// Check permissions
			if ( 'page' == $_POST['post_type'] ) :
				if ( !current_user_can( 'edit_page', $post_id ) ) :
					return $post_id;
			 	elseif ( !current_user_can( 'edit_post', $post_id ) ) :
					return $post_id;
				endif;
			endif;
			// OK, we're authenticated: we need to find and save the data
			if ( $custom_field['id'] == $ds_custom_field_key . 'price' ) :
				$data = ds_strip_comma($_POST[$custom_field['id'] . '_value']);
			else :
				$data = $_POST[$custom_field['id'] . '_value'];
			endif;
			if ( get_post_meta($post_id, $custom_field['id'] . '_value' ) == '') :
				add_post_meta($post_id, $custom_field['id'] . '_value', $data, true);
			elseif ( $data != get_post_meta($post_id,  $custom_field['id'] . '_value', true) ) :
				update_post_meta($post_id, $custom_field['id'] . '_value', $data);
			endif;
			if($custom_field['id']=="add_song") {
				if($data !='') {
					$song_id=explode(",", $data);
					foreach ($song_id as $value) {
						if($value !="") {
							foreach (array('song_title', 'song_price', 'song_preview', 'song_full', 'song_itunes', 'song_amazon', 'song_lyrics', 'song_count') as $item) {
								if(get_post_meta($post_id, $item.$value ) == '')
								{
									add_post_meta($post_id, $item.$value , $_POST[$item.$value], true);
								}
								elseif (stripslashes($_POST[$item.$value]) != get_post_meta($post_id,  $item.$value , true) ) {
									update_post_meta($post_id, $item.$value, stripslashes($_POST[$item.$value]));
								}
							}
						}
					}
					if($_POST['remove_song'] !="" ) {
						$song_id2=explode(",", $_POST['remove_song']);
						foreach ($song_id2 as $value) {
							if($value !="") {
								foreach (array('song_title', 'song_price', 'song_preview', 'song_full', 'song_itunes', 'song_amazon', 'song_lyrics', 'song_count') as $item) {
									delete_post_meta($post_id, $item.$value, get_post_meta($post_id, $item.$value , true));
								}
							}
						}
					}
				}
			}
			if ($data == "") :			
				delete_post_meta($post_id, $custom_field['id'] . '_value', get_post_meta($post_id, $custom_field['id'] . '_value', true));
			endif;
		endforeach;
}

add_action('admin_menu', 'ds_init_custom_fields');
add_action('save_post', 'ds_save_custom_fields');
?>